##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic compression utilities                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate the generation of          ##
## compressed files and their inclusion in users' projects.               ##
############################################################################

## COMPRESSION EXAMPLE (Uncomment lines to use)
##

## First 3 calls to ADD2PACK add enemy, hero and background
## graphics (previously converted to binary data) into the 
## compressed group 'mygraphics'. After that, call to PACKZX7B
## compresses all the data and generates an array with the result
## that is placed in src/mygraphics.c & src/mygraphics.h, ready
## to be included and used by other modules.
##
#$(eval $(call ADD2PACK,mygraphics,gfx/enemy.bin))
#$(eval $(call ADD2PACK,mygraphics,gfx/hero.bin))
#$(eval $(call ADD2PACK,mygraphics,gfx/background.bin))
#$(eval $(call PACKZX7B,mygraphics,src/))

$(eval $(call ADD2PACK,my_pause,c_sprites/pause_menu.bin))
$(eval $(call PACKZX7B,my_pause,c_sprites/))
$(eval $(call ADD2PACK,title_screen,c_sprites/title_screen.bin))
$(eval $(call PACKZX7B,title_screen,c_sprites/))
$(eval $(call ADD2PACK,game_over,c_sprites/game_over.bin))
$(eval $(call PACKZX7B,game_over,c_sprites/))

#Historia
$(eval $(call ADD2PACK,First,c_sprites/First.bin))
$(eval $(call PACKZX7B,First,c_sprites/))
$(eval $(call ADD2PACK,Second,c_sprites/Second.bin))
$(eval $(call PACKZX7B,Second,c_sprites/))
$(eval $(call ADD2PACK,Third,c_sprites/Third.bin))
$(eval $(call PACKZX7B,Third,c_sprites/))
$(eval $(call ADD2PACK,Fourth,c_sprites/Fourth.bin))
$(eval $(call PACKZX7B,Fourth,c_sprites/))
$(eval $(call ADD2PACK,Fifth,c_sprites/Fifth.bin))
$(eval $(call PACKZX7B,Fifth,c_sprites/))
$(eval $(call ADD2PACK,Sixth,c_sprites/Sixth.bin))
$(eval $(call PACKZX7B,Sixth,c_sprites/))
$(eval $(call ADD2PACK,Seventh,c_sprites/Seventh.bin))
$(eval $(call PACKZX7B,Seventh,c_sprites/))
$(eval $(call ADD2PACK,Eighth,c_sprites/Eighth.bin))
$(eval $(call PACKZX7B,Eighth,c_sprites/))
$(eval $(call ADD2PACK,References,c_sprites/References.bin))
$(eval $(call PACKZX7B,References,c_sprites/))
$(eval $(call ADD2PACK,Credits,c_sprites/Credits.bin))
$(eval $(call PACKZX7B,Credits,c_sprites/))
$(eval $(call ADD2PACK,Alternative,c_sprites/Alternative.bin))
$(eval $(call PACKZX7B,Alternative,c_sprites/))



#level1 map 0
$(eval $(call ADD2PACK,level1_map0_pack,src/tilemaps/level1_map0.bin))
$(eval $(call PACKZX7B,level1_map0_pack,src/tilemaps/))
#level1 map 1
$(eval $(call ADD2PACK,level1_map1_pack,src/tilemaps/level1_map1.bin))
$(eval $(call PACKZX7B,level1_map1_pack,src/tilemaps/))
#level1 map 2
$(eval $(call ADD2PACK,level1_map2_pack,src/tilemaps/level1_map2.bin))
$(eval $(call PACKZX7B,level1_map2_pack,src/tilemaps/))
#level1 map 3
$(eval $(call ADD2PACK,level1_map3_pack,src/tilemaps/level1_map3.bin))
$(eval $(call PACKZX7B,level1_map3_pack,src/tilemaps/))

#level2 map 1
$(eval $(call ADD2PACK,level2_map1_pack,src/tilemaps/level2_map1.bin))
$(eval $(call PACKZX7B,level2_map1_pack,src/tilemaps/))
#level2 map 2
$(eval $(call ADD2PACK,level2_map2_pack,src/tilemaps/level2_map2.bin))
$(eval $(call PACKZX7B,level2_map2_pack,src/tilemaps/))
#level2 map 3
$(eval $(call ADD2PACK,level2_map3_pack,src/tilemaps/level2_map3.bin))
$(eval $(call PACKZX7B,level2_map3_pack,src/tilemaps/))


#level3 map 1
$(eval $(call ADD2PACK,level3_map1_pack,src/tilemaps/level3_map1.bin))
$(eval $(call PACKZX7B,level3_map1_pack,src/tilemaps/))
#level3 map 2
$(eval $(call ADD2PACK,level3_map2_pack,src/tilemaps/level3_map2.bin))
$(eval $(call PACKZX7B,level3_map2_pack,src/tilemaps/))
#level3 map 3
$(eval $(call ADD2PACK,level3_map3_pack,src/tilemaps/level3_map3.bin))
$(eval $(call PACKZX7B,level3_map3_pack,src/tilemaps/))
#level3 map 4
$(eval $(call ADD2PACK,level3_map4_pack,src/tilemaps/level3_map4.bin))
$(eval $(call PACKZX7B,level3_map4_pack,src/tilemaps/))
#level3 map 5
$(eval $(call ADD2PACK,level3_map5_pack,src/tilemaps/level3_map5.bin))
$(eval $(call PACKZX7B,level3_map5_pack,src/tilemaps/))
#level3 map 6
$(eval $(call ADD2PACK,level3_map6_pack,src/tilemaps/level3_map6.bin))
$(eval $(call PACKZX7B,level3_map6_pack,src/tilemaps/))

#level4 map 1
$(eval $(call ADD2PACK,level4_map1_pack,src/tilemaps/level4_map1.bin))
$(eval $(call PACKZX7B,level4_map1_pack,src/tilemaps/))
#level4 map 2
$(eval $(call ADD2PACK,level4_map2_pack,src/tilemaps/level4_map2.bin))
$(eval $(call PACKZX7B,level4_map2_pack,src/tilemaps/))
#level4 map 3
$(eval $(call ADD2PACK,level4_map3_pack,src/tilemaps/level4_map3.bin))
$(eval $(call PACKZX7B,level4_map3_pack,src/tilemaps/))
#level4 map 4
$(eval $(call ADD2PACK,level4_map4_pack,src/tilemaps/level4_map4.bin))
$(eval $(call PACKZX7B,level4_map4_pack,src/tilemaps/))
#level4 map 5
#$(eval $(call ADD2PACK,level4_map5_pack,src/tilemaps/level4_map5.bin))
#$(eval $(call PACKZX7B,level4_map5_pack,src/tilemaps/))
#level4 map 6
$(eval $(call ADD2PACK,level4_map6_pack,src/tilemaps/level4_map6.bin))
$(eval $(call PACKZX7B,level4_map6_pack,src/tilemaps/))

#level5 map 1
$(eval $(call ADD2PACK,level5_map1_pack,src/tilemaps/level5_map1.bin))
$(eval $(call PACKZX7B,level5_map1_pack,src/tilemaps/))
#level5 map 2
$(eval $(call ADD2PACK,level5_map2_pack,src/tilemaps/level5_map2.bin))
$(eval $(call PACKZX7B,level5_map2_pack,src/tilemaps/))
#level5 map 3
$(eval $(call ADD2PACK,level5_map3_pack,src/tilemaps/level5_map3.bin))
$(eval $(call PACKZX7B,level5_map3_pack,src/tilemaps/))
#level5 map 4
$(eval $(call ADD2PACK,level5_map4_pack,src/tilemaps/level5_map4.bin))
$(eval $(call PACKZX7B,level5_map4_pack,src/tilemaps/))
#level5 map 5
$(eval $(call ADD2PACK,level5_map5_pack,src/tilemaps/level5_map5.bin))
$(eval $(call PACKZX7B,level5_map5_pack,src/tilemaps/))
#level5 map 6
$(eval $(call ADD2PACK,level5_map6_pack,src/tilemaps/level5_map6.bin))
$(eval $(call PACKZX7B,level5_map6_pack,src/tilemaps/))

#level6 map 1
$(eval $(call ADD2PACK,level6_map1_pack,src/tilemaps/level6_map1.bin))
$(eval $(call PACKZX7B,level6_map1_pack,src/tilemaps/))
#level6 map 2
$(eval $(call ADD2PACK,level6_map2_pack,src/tilemaps/level6_map2.bin))
$(eval $(call PACKZX7B,level6_map2_pack,src/tilemaps/))
#level6 map 3
$(eval $(call ADD2PACK,level6_map3_pack,src/tilemaps/level6_map3.bin))
$(eval $(call PACKZX7B,level6_map3_pack,src/tilemaps/))
#level6 map 4
$(eval $(call ADD2PACK,level6_map4_pack,src/tilemaps/level6_map4.bin))
$(eval $(call PACKZX7B,level6_map4_pack,src/tilemaps/))
#level6 map 5
$(eval $(call ADD2PACK,level6_map5_pack,src/tilemaps/level6_map5.bin))
$(eval $(call PACKZX7B,level6_map5_pack,src/tilemaps/))
#level6 map 6
$(eval $(call ADD2PACK,level6_map6_pack,src/tilemaps/level6_map6.bin))
$(eval $(call PACKZX7B,level6_map6_pack,src/tilemaps/))

#level7 map 1
$(eval $(call ADD2PACK,level7_map1_pack,src/tilemaps/level7_map1.bin))
$(eval $(call PACKZX7B,level7_map1_pack,src/tilemaps/))
#level7 map 2
$(eval $(call ADD2PACK,level7_map2_pack,src/tilemaps/level7_map2.bin))
$(eval $(call PACKZX7B,level7_map2_pack,src/tilemaps/))
#level7 map 3
$(eval $(call ADD2PACK,level7_map3_pack,src/tilemaps/level7_map3.bin))
$(eval $(call PACKZX7B,level7_map3_pack,src/tilemaps/))
#level7 map 4
$(eval $(call ADD2PACK,level7_map4_pack,src/tilemaps/level7_map4.bin))
$(eval $(call PACKZX7B,level7_map4_pack,src/tilemaps/))
#level7 map 5
$(eval $(call ADD2PACK,level7_map5_pack,src/tilemaps/level7_map5.bin))
$(eval $(call PACKZX7B,level7_map5_pack,src/tilemaps/))
#level7 map 6
$(eval $(call ADD2PACK,level7_map6_pack,src/tilemaps/level7_map6.bin))
$(eval $(call PACKZX7B,level7_map6_pack,src/tilemaps/))

#level2 map 3
$(eval $(call ADD2PACK,level_final_pack,src/tilemaps/level_final.bin))
$(eval $(call PACKZX7B,level_final_pack,src/tilemaps/))
############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macros used for compression are ADD2PACK and PACKZX7B:                 ##
##                                                                        ##
##	ADD2PACK: Adds files to packed (compressed) groups. Each call to this ##
##  		  macro will add a file to a named compressed group.          ##
##  PACKZX7B: Compresses all files in a group into a single binary and    ##
##            generates a C-array and a header to comfortably use it from ##
##            inside your code.                                           ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call ADD2PACK,<packname>,<file>))                            ##
##                                                                        ##
##		Sequentially adds <file> to compressed group <packname>. Each     ##
## call to this macro adds a new <file> after the latest one added.       ##
## packname could be any valid C identifier.                              ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname): Name of the compressed group where the file will be added ##
##  (file)    : File to be added at the end of the compressed group       ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call PACKZX7B,<packname>,<dest_path>))                       ##
##                                                                        ##
##		Compresses all files in the <packname> group using ZX7B algorithm ##
## and generates 2 files: <packname>.c and <packname>.h that contain a    ##
## C-array with the compressed data and a header file for declarations.   ##
## Generated files are moved to the folder <dest_path>.                   ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname) : Name of the compressed group to use for packing          ##
##  (dest_path): Destination path for generated output files              ##
##                                                                        ##
############################################################################
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##  * You can omit parameters by leaving them empty.                      ##
##  * Parameters (4) and (5) are optional and generally not required.     ##
############################################################################
