##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
PALETTE=26 15 20 6 1 0 2 8 13 12 14 16 18 19 24 10
#13 1 2 3 6 9 11 12 13 15 16 18 20 24 25 26

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_FOLDER      , src/               ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }
#$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))
$(eval $(call IMG2SP, SET_MODE        , 0                  ))  #{ 0, 1, 2 }
$(eval $(call IMG2SP, SET_OUTPUT      , c               ))  #{ bin, c }
$(eval $(call IMG2SP, SET_FOLDER      , c_sprites/              ))
$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))



#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo1_down.png , 8, 8, enemy_down3))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo1_right.png , 8, 8, enemy_right3))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo1_up.png , 8, 8, enemy_up3))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo1_left.png , 8, 8, enemy_left3))

#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_melee2_down.png , 8, 8, enemy_down2))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_melee2_right.png , 8, 8, enemy_right2))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_melee2_up.png , 8, 8, enemy_up2))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_melee2_left.png , 8, 8, enemy_left2))

#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_melee3_down.png , 8, 8, enemy_down3))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_melee3_right.png , 8, 8, enemy_right3))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_melee3_up.png , 8, 8, enemy_up3))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_melee3_left.png , 8, 8, enemy_left3))

#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_melee4_down.png , 8, 8, enemy_down4))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_melee4_right.png , 8, 8, enemy_right4))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_melee4_up.png , 8, 8, enemy_up4))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_melee4_left.png , 8, 8, enemy_left4))

#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_escudo_down.png , 8, 8, enemy_shield_down))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_escudo_right.png , 8, 8, enemy_shield_right))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_escudo_up.png , 8, 8, enemy_shield_up))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_escudo_left.png , 8, 8, enemy_shield_left))


#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo2_down.png , 8, 8, enemy_shoot_down3))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo2_right.png , 8, 8, enemy_shoot_right3))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo2_up.png , 8, 8, enemy_shoot_up3))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo2_left.png , 8, 8, enemy_shoot_left3))

#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_distancia3_down.png , 8, 8, enemy_shoot_down3))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_distancia3_right.png , 8, 8, enemy_shoot_right3))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_distancia3_up.png , 8, 8, enemy_shoot_up3))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_distancia3_left.png , 8, 8, enemy_shoot_left3))

#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_distancia4_down.png , 8, 8, enemy_shoot_down4))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_distancia4_right.png , 8, 8, enemy_shoot_right4))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_distancia4_up.png , 8, 8, enemy_shoot_up4))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_distancia4_left.png , 8, 8, enemy_shoot_left4))


#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_distancia2_up.png, 8, 8, enemy_shoot_up2))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_distancia2_right.png, 8, 8, enemy_shoot_right2))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_distancia2_left.png, 8, 8, enemy_shoot_left2))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_enemigo_distancia2_down.png, 8, 8, enemy_shoot_down2))

#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_jugador_down.png , 8, 8, player_down3))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_jugador_right.png , 8, 8, player_right3))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_jugador_up.png , 8, 8, player_up3))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_jugador_left.png , 8, 8, player_left3))
#
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/disparo_chikito.jpg , 2, 2, disparo ))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/disparo_enemy_chikito.jpg , 2, 2, disparo_enemy ))
#
#
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Corazon_lleno.jpg , 6, 8, corazon1 ))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Corazon_vacio.jpg , 6, 7, corazon2 ))
#.png
#
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Reference.png, 8, 8, Reference ))

#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_HyperAdrenalina_suelo.png, 8, 8, HyperAdrenalina_suelo ))
#$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sprite_HyperAdrenalina_vacio_muro.png, 8, 8, HyperAdrenalina_muro_vacio ))

$(eval $(call IMG2SP, SET_OUTPUT      , bin               ))  #{ bin, c }
$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/First.png, 128, 128, First ))
$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Second.png, 128, 128, Second ))
$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Third.png, 128, 128, Third ))
$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Fourth.png, 128, 128, Fourth ))
$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Fifth.png, 128, 128, Fifth ))
$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Sixth.png, 128, 128, Sixth ))
$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Seventh.png, 128, 128, Seventh ))
$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Eighth.png, 128, 128, Eighth ))
$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/References.png, 128, 128, References ))
$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Credits.png, 128, 128, Credits ))
$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/Alternative.png, 128, 128, Alternative ))
$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/pause_menu.png, 128, 128, HyperAdrenalina_pause_menu ))
$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/title_screen.png, 128, 128, HyperAdrenalina_title_screen ))
$(eval $(call IMG2SP, CONVERT         , src/converted_sprites/game_over.png, 128, 128, HyperAdrenalina_game_over ))




$(eval $(call IMG2SP, SET_MODE        , 0                  ))  #{ 0, 1, 2 }
$(eval $(call IMG2SP, SET_FOLDER      , src/tilemaps            ))
$(eval $(call IMG2SP, SET_OUTPUT      , c               ))  #{ bin, c }
$(eval $(call IMG2SP, SET_IMG_FORMAT  , zgtiles            ))	#{ sprites, zgtiles, screen }
#Convertimos tiles
$(eval $(call IMG2SP, CONVERT         , assets/maps/tileset.png, 8, 8, tileset_buena))



##
## OLD MACROS (For compatibility)
##

## Example firmware palette definition as variable in cpct_img2tileset format

# PALETTE={0 1 3 4 7 9 10 12 13 16 19 20 21 24 25 26}

## AUTOMATED IMAGE CONVERSION EXAMPLE (Uncomment EVAL line to use)
##
##    This example would convert img/example.png into src/example.{c|h} files.
##    A C-array called pre_example[24*12*2] would be generated with the definition
##    of the image example.png in mode 0 screen pixel format, with interlaced mask.
##    The palette used for conversion is given through the PALETTE variable and
##    a pre_palette[16] array will be generated with the 16 palette colours as 
##	  hardware colour values.

#$(eval $(call IMG2SPRITES,img/example.png,0,pre,24,12,$(PALETTE),mask,src/,hwpalette))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is IMG2SPRITES, which has up to 9 parameters:##
##  (1): Image file to be converted into C sprite (PNG, JPG, GIF, etc)    ##
##  (2): Graphics mode (0,1,2) for the generated C sprite                 ##
##  (3): Prefix to add to all C-identifiers generated                     ##
##  (4): Width in pixels of each sprite/tile/etc that will be generated   ##
##  (5): Height in pixels of each sprite/tile/etc that will be generated  ##
##  (6): Firmware palette used to convert the image file into C values    ##
##  (7): (mask / tileset / zgtiles)                                       ##
##     - "mask":    generate interlaced mask for all sprites converted    ##
##     - "tileset": generate a tileset array with pointers to all sprites ##
##     - "zgtiles": generate tiles/sprites in Zig-Zag pixel order and     ##
##                  Gray Code row order                                   ##
##  (8): Output subfolder for generated .C/.H files (in project folder)   ##
##  (9): (hwpalette)                                                      ##
##     - "hwpalette": output palette array with hardware colour values    ##
## (10): Aditional options (you can use this to pass aditional modifiers  ##
##       to cpct_img2tileset)                                             ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call IMG2SPRITES,(1),(2),(3),(4),(5),(6),(7),(8),(9), (10))) ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##                                                                        ##
##  * You can omit parameters but leaving them empty. Therefore, if you   ##
##  wanted to specify an output folder but do not want your sprites to    ##
##  have mask and/or tileset, you may omit parameter (7) leaving it empty ##
##     $(eval $(call IMG2SPRITES,imgs/1.png,0,g,4,8,$(PAL),,src/))        ##
############################################################################
