;Copyright 2020, SoftBytes
;This file is part of Liam's Awakening.
;
;   Liam's Awakening is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;   (at your option) any later version.
;
;   Liam's Awakening is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with Liam's Awakening.  If not, see https://www.gnu.org/licenses/.

;; Include all CPCtelera constant definitions, macros and variables
.include "cpctelera.h.s"
.include "sys/render.h.s"
.include "man/game.h.s"
.include "man/menu.h.s"
.include "man/end_game.h.s"
.include "man/interruptions.h.s"
.include "music/main_theme.h.s"
.include "music/Instruments_SFX.h.s"
.include "man/story.h.s"
;;
;; Start of _DATA area 
;;  SDCC requires at least _DATA and _CODE areas to be declared, but you may use
;;  any one of them for any purpose. Usually, compiler puts _DATA area contents
;;  right after _CODE area contents.
;;
.area _DATA
.area _CODE

;; 
;; Declare all function entry points as global symbols for the compiler.
;; (The linker will know what to do with them)
;; WARNING: Every global symbol declared will be linked, so DO NOT declare 
;; symbols for functions you do not use.
;;

.globl cpct_akp_musicInit_asm
.globl cpct_akp_SFXInit_asm


_main::
   ;; Disable firmware to prevent it from interfering with string drawing
   ;call cpct_disableFirmware_asm

   call set_man_ir
   ;Init musica
   ld de, #_musica_juego
   call cpct_akp_musicInit_asm
   ;Init SFX
   ld de, #_sfx_juego
   call cpct_akp_SFXInit_asm


   call render_set_video_mode
   ld a, #0x01
   loop_game:
      dec a
      jr nz, direct_to_game
      call man_menu_init
      call man_menu_run
      ld a, #0
      call story_tell
      call man_game_reset
      direct_to_game:

      call man_game_init
      call man_game_run
      or a
      jr nz,loop_game
      call man_end_game_init
      call man_end_game_run
   jr loop_game
