;Copyright 2020, SoftBytes
;This file is part of Liam's Awakening.
;
;   Liam's Awakening is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;   (at your option) any later version.
;
;   Liam's Awakening is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with Liam's Awakening.  If not, see https://www.gnu.org/licenses/.

.include "entities.h.s"
.include "../templates/templates.h.s"
.include "cpctelera.h.s"
.include "game.h.s"
.include "story.h.s"
.include "../sys/render.h.s"

.globl cpct_memcpy_asm
.globl cpct_setPALColour_asm
.globl cpct_akp_SFXPlay_asm

_entities:: .ds e_size*e_max_entities
_hueco:: .db 00

;Auxiliares
_reserved_entities:: .db 0x00 ;cantidad entidades
_contador_apply:: .db 00      ;Contador for all
_funcion_a_hacer:: .dw 0x0000 ;Auxiliar funcion
_componente_masc:: .db 00     ;Auxiliar mascara
_contador_ent:: .db 00
_contador_mini_ent:: .db 00   ;Contador minibucle
_pos_x_map:: .db 00
_pos_y_map:: .db 00

find_next_free_pos: ;Te coje la siguiente posicion de memoria vacia
   ld IX, #_entities
   new:
   ld a, e_type(IX)
   inc a
   dec a
   jr z, fin_create
   ld bc, #e_size
   add IX, bc
   jr new
   ld a, (_reserved_entities)
   inc a
   ld (_reserved_entities), a
   fin_create:
ret

create_one_entity:
;Tienes que tener en hl lo que quieres copiar
    ld a, (_contador_ent)
    ld b, a
    ld a, #e_max_entities
    sub b
    jr z, fin_new_entity
    ;si llega aqui tiene espacio de sobra, sumamos 1 a entidades
    inc b
    ld a, b
    ld (_contador_ent), a

    call find_next_free_pos
    push IX
    pop de
    ;ld de, IX , el cual no se puede hacer pero usando la pila te deja
    ld bc,#e_size
    call cpct_memcpy_asm ;de-> pos memoria a copiar , hl -> cosas a copiar, bc ->numero de baits a copiar


    fin_new_entity:
ret     
;[][][][][][1][][]

destroy_entity:
    ;Se le pasa por OX
    ld  a, e_type(IX)
    inc a
    dec a
    jr z, skip_destroy

    ld a, (_contador_ent)
    dec a
    ld (_contador_ent) , a
    ld e_type(IX), #e_type_invalid
    skip_destroy:
ret

kill_all_entities:
    ld  IX, #_entities
    ld  bc, #e_size
    ld  d, #e_max_entities

    kill_all_loop:
        call destroy_entity
        add IX, bc          ;; Salta a la siguiente
        dec d
        jr nz, kill_all_loop
ret
kill_all_non_player_entities:
    ld  IX, #_entities
    ld  bc, #e_size
    ld  d, #e_max_entities
    add IX, bc
    kill_all_non_player_loop:
        call destroy_entity
        add IX, bc          ;; Salta a la siguiente
        dec d
        jr nz, kill_all_non_player_loop
ret
update_dead_entities:
    ld a, #e_max_entities
    ld (_contador_apply), a
    ld IX, #_entities
    new_apply_to_dead:
    
    ld a, e_type(IX) 
    ld b, #0x80
    and b ;1000 0000
    jr nz, this_apply_to_dead
    jp next_apply_to_dead
    this_apply_to_dead:
    ;Comprobar si lo que va a morir es un jugador
    ;Restarle 1 vida en el game
    ;Reposicionar el sprite de jugador en vez de destruir la entidad
    ;quitarle que va a morir
    
    ld  a, e_type(IX)
    ld  b, #e_type_player
    and b                                   ;; and a, b

    jr z, non_player_destruction            ;; si no es jugador, matala de normal

    ;; Volver a poner el tipo jugador
    ld  a, #e_type_player
    ld e_type(IX), a

    ;; Cambiar su posicion esto luego hay que ver si lo cambiamos segun el mapa
    ld  a, (_pos_x_map)
    ld  e_x(IX), a
    ld  a, (_pos_y_map)
    ld  e_y(IX), a

    ;;SFX de morir player
            ;push IX
            ;ld l, #4;2    ;Number of instrument in sfx song, same as arkos tracker
            ;ld h, #11   ; volume 0=off 15=max
            ;ld e, #40;50   ;Note of the instrument 0-127
            ;ld d, #0  ;speed - 0=as originak 1 is fastest
            ;ld bc, #0000 ;inverted pitch 
            ;ld a, #2 ;Canal de audio 2= ambos
            ;call cpct_akp_SFXPlay_asm
            ;pop IX
    ;; Decrementar las vidas, si son cero, el game acaba
    ld b, #50
    death_loop1:
    dec b
    halt
    halt
    jr nz, death_loop1
            ;push IX
            ;ld l, #4;2    ;Number of instrument in sfx song, same as arkos tracker
            ;ld h, #12   ; volume 0=off 15=max
            ;ld e, #50;50   ;Note of the instrument 0-127
            ;ld d, #0  ;speed - 0=as originak 1 is fastest
            ;ld bc, #0000 ;inverted pitch 
            ;ld a, #2 ;Canal de audio 2= ambos
            ;call cpct_akp_SFXPlay_asm
            ;pop IX
    ld b, #50
    death_loop2:
    dec b
    halt
    halt
    jr nz, death_loop2
    cpctm_clearScreen_asm 0x00

    ld  a, (vidas)
    dec a
    ld (vidas), a
    call render_my_life
    ld  a, (vidas)
    dec a
    inc a


    ;ld l, #0x10
    ;ld h, #0x01
    ;call cpct_setPALColour_asm
    ;ld l, #0x0B
    ;ld h, #0x01
    ;call cpct_setPALColour_asm

    jr nz , next_apply_to_dead

    non_player_destruction:

    ;;Comprobamos que es una hyperadrenaline
    ld  a, e_type(IX)
    ld  b, #e_type_hyper_adrenaline
    and b 

    jr z, non_hyper_adrenaline_destruction 
        ld  a, (hyperadrenaline)
        inc a
        ld (hyperadrenaline), a
        
        ;ld  a, #5
        ;ld (vidas), a

    non_hyper_adrenaline_destruction:
    ;Reference
    ld  a, e_type(IX)
    ld  b, #e_type_reference
    and b 
    jr z, non_reference_destruction 

      ld a, #8
      call story_tell
    non_reference_destruction:

    ;Comprobador de vidas de los enemigos
    ;0x02

    ld  a, e_type(IX)
    ld  b, #e_type_enemy
    and b 
    jr z, non_enemy

            ;;SFX de muerte enemigo
            ;push IX
            ;ld l, #1    ;Number of instrument in sfx song, same as arkos tracker
            ;ld h, #9   ; volume 0=off 15=max
            ;ld e, #33;50   ;Note of the instrument 0-127
            ;ld d, #0  ;speed - 0=as originak 1 is fastest
            ;ld bc, #0000 ;inverted pitch 
            ;ld a, #2 ;Canal de audio 2= ambos
            ;call cpct_akp_SFXPlay_asm
            ;pop IX

        ld a, e_vidas(IX)
        dec a
        ld e_vidas(IX), a
        jr z, non_enemy
        ld a, #0x02
        ld e_type(IX), a



        jr next_apply_to_dead
    non_enemy:


    call clear_entity_2_screen
    call destroy_entity

    next_apply_to_dead:

    ;siguiente entidad en IX
    ld bc, #e_size
    add IX, bc
    ;Comprobamos si hemos llegado al maximo de entidades
    ld a, (_contador_apply)
    dec a
    ld (_contador_apply), a
    jr z ,end_entity_dead
    jp new_apply_to_dead
    end_entity_dead:
ret

;En B le pasas la mascara a aplicar
;En hl la funcion que se hace
apply_for_all:
    ld a, b
    ld (_componente_masc), a
    ld a, #e_max_entities
    ld (_contador_apply), a
    ld (_funcion_a_hacer) , hl
    ld IX, #_entities
    new_apply:

    ld a, e_type(IX)
    inc a
    dec a
    jr z ,pasar_Siguiente
    
    ld a, e_comp(IX) 
    and b             
    sub b             
    jr nz, pasar_Siguiente


    ld bc, #pasar_Siguiente
    ;Cargas en bc adonde tiene que volver a saltar cuando vuelva de un ret, esto es como
    ;un call que no podemos hacer porque la funcion no es algo que sepamos, 
    ;si no que se nos pasa por hl
    push bc
    jp (hl) 

    pasar_Siguiente:
    ld  hl , (_funcion_a_hacer)
    
    ld bc, #e_size
    add IX, bc

    ld a, (_componente_masc)
    ld b, a
    ld a, (_contador_apply)
    dec a
    ld (_contador_apply), a
    jr nz ,new_apply

ret

apply_for_all_pairs:
    ld a, b
    ld (_componente_masc), a
    ld a, #e_max_entities
    ld (_contador_apply), a
    ld (_funcion_a_hacer) , hl
    ld IX, #_entities
    new_apply_pairs:

    ld a, e_type(IX)
    inc a
    dec a
    jr z ,pasar_Siguiente_pairs
    
    ld a, e_comp(IX) 
    and b             
    sub b             
    jr nz, pasar_Siguiente_pairs

    ;Ahora hacer mini bucle interno para ver si hay otra collider en el array
        
        
        ;;;;;;;;;;;;;;;;;;;;;;
        ; Calculate how much 
        ; iterations are left 
        ; since the first counter
        ;;;;;;;;;;;;;;;;;;;;;;
        ld a, (_contador_apply) ;
        dec a                 ;
        ;;;;;;;;;;;;;;;;;;;;;;;
        ld (_contador_mini_ent),a
        jr z, pasar_Siguiente ;Si la ultima entidad del array entera es colliseable esto evitaria que el programa explotase

        push IX;Guardamos IX en la pila
        pop IY
        ld bc, #e_size
        add IY, bc ;Pasamos al a siguiente entidad

        new_mini_apply:
            ld a, e_type(IY)
            inc a
            dec a
            jr z ,next_mini_bucle
            

            ld a, e_comp(IX) 
            and b             
            sub b             
            jr nz, next_mini_bucle

                ;Ha comprobado las 2 mascaras y pasa a la funcion de colision
                ld bc, #next_mini_bucle
                push bc
                jp (hl) 


        next_mini_bucle:
            ld  hl , (_funcion_a_hacer)
            ld bc, #e_size
            add IY, bc


            ld a, (_componente_masc)
            ld b, a

            ld a, (_contador_mini_ent)
            dec a
            ld (_contador_mini_ent), a
            jr nz ,new_mini_apply


    pasar_Siguiente_pairs:
    ld  hl , (_funcion_a_hacer)
    
    ld bc, #e_size
    add IX, bc

    ld a, (_componente_masc)
    ld b, a
    ld a, (_contador_apply)
    dec a
    ld (_contador_apply), a
    jr nz ,new_apply_pairs

ret

;---------------------------------:
;- Reposiciona al jugador-:
;- Le llega en a la x y en b la y-;
;- Pone en IX al jugador-;
;---------------------------------;
reposition_player:
    ld  IX, #_entities

    ld (_pos_x_map), a
    ld e_x(IX), a
    ld a, b
    ld (_pos_y_map), a
    ld e_y(IX), b
ret
