;Copyright 2020, SoftBytes
;This file is part of Liam's Awakening.
;
;   Liam's Awakening is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;   (at your option) any later version.
;
;   Liam's Awakening is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with Liam's Awakening.  If not, see https://www.gnu.org/licenses/.

.include "game.h.s"

.include "cpctelera.h.s"
.include "entities.h.s"
.include "maps.h.s"
.include "level.h.s"
.include "story.h.s"

.include "pause_menu.h.s"

.include "../sys/render.h.s"
.include "../sys/physics.h.s"
.include "../sys/collision.h.s"
.include "../sys/collider.h.s"
.include "../sys/ai.h.s"
.include "../sprites/sprites.h.s"
.include "../templates/templates.h.s"

;-----------------------;
vidas: .db #0x00
death_counter: .db #0x00
mapa: .dw #0x0000
hyperadrenaline: .db #0x00
pause_pressed: .db #0x00
exit_menu_pressed: .db #0x00
;-----------------------;

man_game_init:

   ld hl , #template_player
   call create_one_entity
   
   ;ld hl , #template_enemy
   ;call create_one_entity
   ;ld e_x(IX), #0x20
   ;
   ;ld hl , #template_enemy
   ;call create_one_entity
   ;ld e_x(IX), #0x30
   ;ld e_dir(IX), #0x02

   ld a, #0x05
   ld (vidas), a
   ld a, #0x00
   ld (exit_menu_pressed), a
   ld (last_hyper_Adrenaline), a
   ;Cargamos tileset GARCIAS
   call set_tileset

   ld a, #0x00
   call man_map_charge

   ld b, #0x01
   ld a, b
   ld (_contador_ent), a
   call charge_level

ret

man_game_reset:
   ld a, #0x00
   ld (hyperadrenaline), a
   ld a, #0x00
   ld (death_counter), a
ret

man_game_run:

   ;Render mapa

   ;Cargamos mapa 1
   ;Colocamos el contador
    loop: 

      ;Comprobamos si han recogido el hyperadrenaline
      call check_level
      ;call game_update
      ;Actualizar IA
      call update_ai_all 
      ;Actualziar Fis
      call update_physics_all
      call check_end_of_map
      ;Actualizar Coliders
      call update_collision_all
      
      call update_collider_all
      ;Actualizar Anim


      ;Actualizar Render
      ;Cargar el mapa
      call draw_tilemap

      ;dibujamos las vidas
      call render_my_life
      
      call update_render_all ;Cargar el sprite entero
      ;Buscar entidades marcadas
      call update_dead_entities
      ;Actualizar Entidades
      ;call esperar_1_frame_game
      ;Comprobar si hay que cambiar de mapa
      call man_map_next
      ;;Comprobamos si han recogido el hyperadrenaline
      ;call check_level

      ld a, (pause_pressed)
      dec a
      jr nz, no_pause_pressed
         call man_pause_run
         dec a
         jr nz, no_pause_pressed
         ld (vidas), a
         ld IX, #_entities
         ld e_type(IX), a
         inc a
         ld (exit_menu_pressed) ,a
      no_pause_pressed:
      ld a, #0
      ld (pause_pressed), a

      ld a, (hyperadrenaline)
      ld b, #07
      sub b
      jr z, final_game_congrats

      


      ;Comprobar fin del juego, sin vidas
      ld a, (vidas)
      or a
   jr nz ,  loop
   final_game:
   ld a, #1
   ld (death_counter), a

   call clear_all_entities
   call change_screen_to_C000
   call kill_all_non_player_entities
   cpctm_clearScreen_asm 0x00
   ;;call kill_all_entities

   ld a, (exit_menu_pressed)
ret

final_game_congrats:
ld a, #1
ld (exit_menu_pressed),a 
call kill_all_entities
;Historia Final
ld a, #7
call story_tell
;Creditos
ld a, #9
call story_tell
;0 muertes
ld a, (death_counter)
or a
jr nz, final_game
   ld a, #10;
call story_tell

jr final_game
