;Copyright 2020, SoftBytes
;This file is part of Liam's Awakening.
;
;   Liam's Awakening is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;   (at your option) any later version.
;
;   Liam's Awakening is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with Liam's Awakening.  If not, see https://www.gnu.org/licenses/.

.include "level.h.s"
.include "../templates/level_template.h.s"
.include "cpctelera.h.s"
.include "maps.h.s"
.include "entities.h.s"
.include "game.h.s"
.include "story.h.s"

level_to_charge:: .dw 0000
last_hyper_Adrenaline: .db 00
;level_id = 0
;level_initial_map = 1 ;2 bites
;level_hyper_needed = 2
;level_player_x = 3
;level_player_y = 4

;---------------------------;
;-       Charge_level      -;
;---------------------------;
;- Carga el nivel de la id -;
;-     que recibe por b    -;
;---------------------------;

charge_level::

    ld IX, #level_0
    jr first_level_charge_loop
    level_loop_charge:
        ld a, b
        ld bc, #0x0005
        add IX, bc
        ld b, a
        first_level_charge_loop:
        ld a, level_id(IX)
        sub b
    jr nz, level_loop_charge
    ld a,  level_initial_map(IX)
    ld (_id_mapa_nuevo), a
    ld (level_to_charge), IX
    call man_map_next
    ld  IX, (level_to_charge)

    ld a, level_player_y(IX)
    ld b, a
    ld a, level_player_x(IX)

    call reposition_player

ret
;---------------------------;
;-       Check_level      -;
;---------------------------;
;- Se le pasa el numero de hyperadrenalines que tiene por hyperadrenaline la variable del game -;
;- Busca el sigiente nivel segun la hyperadrenaline del jugador-;
;---------------------------;
check_level::
    ld a, (last_hyper_Adrenaline)
    ld b, a
    ld a, (hyperadrenaline)
    sub b
    jr z, final_check_level
        ld a, (hyperadrenaline)
        ld (last_hyper_Adrenaline), a
        ld b, a

        ld IX, #level_0
        jr first_level_check_loop
        level_loop_check:
            ld a, b
            ld bc, #0x0005
            add IX, bc
            ld b, a
            ld a, level_id(IX)
            or a
            jr z, final_check_level

            first_level_check_loop:
            ld a, level_hyper_needed(IX)
            sub b
            jr nz, level_loop_check

            
            ld a, level_id(IX)
            ld b, a
            call charge_level
            cpctm_clearScreen_asm 0x00

            ld a, (hyperadrenaline)
            call story_tell

    final_check_level:
ret