;Copyright 2020, SoftBytes
;This file is part of Liam's Awakening.
;
;   Liam's Awakening is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;   (at your option) any later version.
;
;   Liam's Awakening is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with Liam's Awakening.  If not, see https://www.gnu.org/licenses/.

.include "maps.h.s"
.include "../templates/map_templates.h.s"
.include "../sys/render.h.s"
.include "../sys/physics.h.s"
.include "entities.h.s"
.include "game.h.s"
.include "cpctelera.h.s"
; Structura de mapa
;e_map_id              = 0 ;id del mapa
;e_map_tile            = 1 ;Posicion de memoria al tile 2 bytes
;e_map_enemytemplate   = 3 ;Posicion de memoria del template con los enemigos del mapa
;e_map_izq             = 5 ;Marca si tiene salida a la izquierda
;e_map_izq_next        = 6 ;id del mapa a la izquierda
;e_map_der             = 7 ;Marca si tiene salida a la derecha
;e_map_der_next        = 8 ;Id del mapa a la derecha
;e_map_arr             = 9 ;Marca si tiene salida arriba
;e_map_arr_next        = 10;Id del mapa de arriba
;e_map_abj             = 11 ;Marca si tiene salida abajo
;e_map_abj_next        = 12;Id del mapa abajo

.globl cpct_zx7b_decrunch_s_asm


; Variables


_id_mapa_actual:: .db 00
_id_mapa_nuevo:: .db 00

;---------------------------------:
;- Carga el mapa que se le indica-:
;- Se le pasa el mapa a cargar por a -;
;---------------------------------;
man_map_charge:
    ld (_id_mapa_actual), a
    ld (_id_mapa_nuevo), a;para que sepa que no tiene que cambiar de mapa
    call search_map
    ;;Ya tenemos el mapa en hl
    push hl
    pop IX

    ld a, #0x01
    ld (_contador_ent), a
    ;;Descomprimimos el mapa
    ld a, e_map_tile(IX)
    ld l, a
    ld a, 1+e_map_tile(IX)
    ld h,a

    ld de, #0x0FFF
    call cpct_zx7b_decrunch_s_asm
    ;;Cargar enemigos
        ld l , e_map_enemytemplate(IX)
        ld h , 1+e_map_enemytemplate(IX)
        push hl
        pop IY
        push IX 
        loop_creacion_enemigos_mapa:
            ld l , (IY) ;Se carga el template
            ld h , 1(IY)
            push hl
            ld bc, #0xFFFF
            add hl,bc
            pop hl
            jr nc, fin_creador_enemigos_map
                call create_one_entity
                ld b,2(IY)
                ld e_x(IX), b
                ld b,3(IY)
                ld e_y(IX), b
                ld b, 4(IY)
                ld e_dir(IX), b
                ld bc, #0x0005
                add IY,bc
                jr loop_creacion_enemigos_mapa
    fin_creador_enemigos_map:
    pop IX
ret

;
; Se le pasa por a el id y te devuelve en hl la posicion de memoria del mapa
;
;

search_map::
ld b, a ;Pasamos el id a buscar a b
    ld IX, #array_mapas
    loop_busqueda_mapas:
        ld a, (IX)
        sub b
        jr z, mapa_encontrado
        ld a,b
        ld bc, #0x0003
        add IX, bc
        ld b,a
        jr loop_busqueda_mapas
    mapa_encontrado:
    ld l, 1(IX)
    ld h, 2(IX)
ret
;---------------------------------:
;- Comprueba si tiene que cambiar de mapa-:
;- Se le pasa la direccion por la que quiere salir el jugador en _dir_salida-;
;- Pasa el mapa a cargar por a -;
;---------------------------------;
check_end_of_map:
    ; comprueba si tiene salida por la derecha
    ; por ahora se llamara a search map para meterlo en IX esto es para hacer pruebas
    ld a, (_dir_salida)
    or a
    jr z, map_check_end
    ld a, (_id_mapa_actual)
    call search_map
    push hl
    pop IX


    map_check_der:
    ld a, (_dir_salida)
    ld b, e_map_der(IX)
    sub b
    jr nz, map_check_abj
    ld a, e_map_der_next(IX)
    ld (_id_mapa_nuevo), a
    jr map_check_end
    
    ; comprueba si tiene salida por abajo
    map_check_abj:
    ld a, (_dir_salida)
    ld b, e_map_abj(IX)
    sub b
    jr nz, map_check_izq
    ld a, e_map_abj_next(IX)
    ld (_id_mapa_nuevo), a
    jr map_check_end

    ; comprueba si tiene salida por la izquierda
    map_check_izq:
    ld a, (_dir_salida)
    ld b, e_map_izq(IX)
    sub b
    jr nz, map_check_arr
    ld a, e_map_izq_next(IX)
    ld (_id_mapa_nuevo), a
    jr map_check_end

    ; comprueba si tiene salida por arriba
    map_check_arr:
    ld a, (_dir_salida)
    ld b, e_map_arr(IX)
    sub b
    jr nz, map_check_end
    ld a, e_map_arr_next(IX)
    ld (_id_mapa_nuevo), a

    map_check_end:
    
ret

;---------------------------------:
;- Reposiciona al jugador al empezar un nuevo mapa-:
;- Le llega en d la direccion de la que ha salido del otro mapa-;
;- Llama al reposition_player del entities-;
;---------------------------------;
reposition_player_new_map:
    ld  IX, #_entities
    ;Comprobamos si sale de la derecha para meterlo en la izquierda
    positioning_left:
    dec d
    jr nz, positioning_up
    ld a, #0x01
    ld b, e_y(IX)
    jr confirm_reposition 
    ;Comprobamos si sale de de abajo para meterlo arriba
    positioning_up:
    dec d
    jr nz, positioning_right
    ;ld a, #0x1D
    ld a, e_x(IX)
    ld b, #0x02
    jr confirm_reposition 
    ;Comprobamos si sale de la izquierda para meterlo en la derecha
    positioning_right:
    dec d
    jr nz, positioning_down
    ld a, #0x3A
    ld b, e_y(IX)
    jr confirm_reposition 
    ;Comprobamos si sale de arriba para meterlo abajo
    positioning_down:
    dec d
    jr nz, reposition_player_new_map
    ;ld a, #0x1D
    ld a, e_x(IX)
    ld b, #0x70;6E
    
    confirm_reposition:
    call reposition_player

    fin_reposition_player_new_map:
ret
;e_map_izq             = 5 ;Marca si tiene salida a la izquierda
;e_map_izq_next        = 6 ;id del mapa a la izquierda
;e_map_der             = 7 ;Marca si tiene salida a la derecha
;e_map_der_next        = 8 ;Id del mapa a la derecha
;e_map_arr             = 9 ;Marca si tiene salida arriba
;e_map_arr_next        = 10;Id del mapa de arriba
;e_map_abj             = 11 ;Marca si tiene salida abajo
;e_map_abj_next        = 12;Id del mapa abajo

;---------------------------------:
;- Cambia el mapa actual-:
;- Se le pasa el id del nuevo mapa en _id_mapa_nuevo-;
;- Si el id del nuevo mapa es distinto al del actual cambia de mapa-;
;---------------------------------;
man_map_next:
    ld a, (_id_mapa_actual)
    ld b, a
    ld a, (_id_mapa_nuevo)
    sub b
    jr z, fin_man_map_next
    call clear_all_entities
    call kill_all_non_player_entities
    ld a, (_id_mapa_nuevo)
    call man_map_charge
    ld a, (_dir_salida)
    ld d, a
    call reposition_player_new_map
    fin_man_map_next:
ret