;Copyright 2020, SoftBytes
;This file is part of Liam's Awakening.
;
;   Liam's Awakening is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;   (at your option) any later version.
;
;   Liam's Awakening is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with Liam's Awakening.  If not, see https://www.gnu.org/licenses/.
.include "story.h.s"
.include "cpctelera.h.s"
.include "../sys/render.h.s"

story_tell::
;;Cargamos la imagen de la historia y la dejamos en pantalla X tiempo
;;Le pasamos por a la imagen a cargar

  push IX
    ld hl, #story_Game
    dec hl
    dec hl
    inc a
    loop_story_count:
    inc hl
    inc hl
    dec a
    jr nz, loop_story_count
    push hl
    pop IX

    ld l, (IX)
    ld h, 1(IX)

  ld de, #0xAFFF
  call cpct_zx7b_decrunch_s_asm
    call render_decrunched_image
    ;Esperar X tiempo para que el jugador lea la historia

    ;esperar al espacio
    story_pressed_spc:
    ;call cpct_scanKeyboard_f_asm
        ld hl, #0x8005 
        call cpct_isKeyPressed_asm
        or a
    jr nz, story_pressed_spc

    loop_story:
    ;call cpct_scanKeyboard_f_asm


        ;;Tecla M para entrar al mute
            ld hl, #0x4004
        call cpct_isKeyPressed_asm
        or a
        jr z, no_escape_from_music_story_menu
        ld a,(man_mute_music)
        dec a
        ld (man_mute_music), a
        jr z, loop_story_dont_press_m
        ld a,#1
        ld (man_mute_music), a
        call cpct_akp_stop_asm
        loop_story_dont_press_m:
        ;call cpct_scanKeyboard_f_asm
            ld hl, #0x4004
        call cpct_isKeyPressed_asm
        or a
        jr nz, loop_story_dont_press_m
    
        no_escape_from_music_story_menu:


        ld hl, #0x1009 ;Joystick_shoot1_control
        call cpct_isKeyPressed_asm
        or a
        jr nz, end_loop_story
        ld hl, #0x2009 ;Joystick_shoot1_control
        call cpct_isKeyPressed_asm
        or a
        jr nz, end_loop_story
        ;Tecla Espacio para comenzar juego
        ld hl, #0x8005 
        call cpct_isKeyPressed_asm
        or a
    jr z, loop_story
    end_loop_story:


       loop_dont_press_spc:
       ld hl, #0x1009 ;Joystick_shoot1_control
        call cpct_isKeyPressed_asm
        or a
        jr nz, loop_dont_press_spc
        ld hl, #0x2009 ;Joystick_shoot1_control
        call cpct_isKeyPressed_asm
        or a
        jr nz, loop_dont_press_spc
        ld hl, #0x8005 ;Space
        call cpct_isKeyPressed_asm
        or a
        jr nz, loop_dont_press_spc
    
   cpctm_clearScreen_asm 0x00
  pop IX
ret

story_Game::
.dw #_First_end ;Inicio del juego
.dw #_Second_end ;Primer fragmento hyperAdrenalina
.dw #_Third_end ;Segundo fragmento hyperAdrenalina
.dw #_Fourth_end ;Tercer fragmento hyperAdrenalina
.dw #_Fifth_end ;Cuarto fragmento hyperAdrenalina
.dw #_Sixth_end ;Quinto fragmento hyperAdrenalina
.dw #_Seventh_end ;Sexto fragmento hyperAdrenalina
.dw #_Eighth_end ;Septimo fragmento hyperAdrenalina
.dw #_References_end ;Easter Egg Principe de Persia
.dw #_Credits_end ;Creditos
.dw #_Alternative_end ;Creditos