
;Copyright 2020, SoftBytes
;This file is part of Liam's Awakening.
;
;   Liam's Awakening is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;   (at your option) any later version.
;
;   Liam's Awakening is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with Liam's Awakening.  If not, see https://www.gnu.org/licenses/.

.include "cpctelera.h.s"
.include "ai.h.s"
.include "physics.h.s"
.include "../man/entities.h.s"
.include "../templates/templates.h.s"
.include "../sprites/sprites.h.s"


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;IA ESPECIAL DEL PRIMER TIPO DE ENEMIGO;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;
;enemy_ai_1:
;   
;ret
;---------------------------------:
;- IA del enemigo 2-:
;- Se mueve de lado a lado horizontalmente-;
;---------------------------------;
enemy_ai_2:
    call behaviour_horizontal
    call change_sprite_to_dir_melee_1
ret

;---------------------------------:
;- IA del enemigo 2_Upgraded-:
;- Se mueve de lado a lado horizontalmente-;
;---------------------------------;
enemy_ai_2_Upgraded:
    ld a, e_vidas(IX)
    dec a 
    jr nz, non_enraged_2
    enraged_2:
    call behaviour_horizontal_search
    call change_sprite_to_dir_melee_4
    jr fin_enemy_ai_2_Upgraded
    non_enraged_2:
    call behaviour_horizontal
    call change_sprite_to_dir_melee_2
    fin_enemy_ai_2_Upgraded:
ret
;---------------------------------:
;- IA del enemigo 3-:
;- Se mueve de lado a lado verticalmente-;
;---------------------------------;
enemy_ai_3:
    call behaviour_vertical
    call change_sprite_to_dir_melee_1
ret
;---------------------------------:
;- IA del enemigo 3_Upgraded-:
;- Se mueve de lado a lado verticalmente-;
;---------------------------------;
enemy_ai_3_Upgraded:
    ld a, e_vidas(IX)
    dec a 
    jr nz, non_enraged_3
    enraged_3:
    call behaviour_vertical_search
    call change_sprite_to_dir_melee_4
    jr fin_enemy_ai_3_Upgraded
    non_enraged_3:
    call behaviour_vertical
    call change_sprite_to_dir_melee_2
    fin_enemy_ai_3_Upgraded:
ret
;---------------------------------:
;- IA del enemigo shield_h-:
;- Se mueve de lado a lado horizontalmente-;
;---------------------------------;
enemy_ai_shield_h:
    call behaviour_horizontal
    call change_sprite_to_dir_shield
ret
;---------------------------------:
;- IA del enemigo shield_v-:
;- Se mueve de lado a lado verticalmente-;
;---------------------------------;
enemy_ai_shield_v:
    call behaviour_vertical
    call change_sprite_to_dir_shield
ret

;---------------------------------:
;- IA del enemigo 4-:
;- Esta quieto y dispara-;
;---------------------------------;
enemy_ai_4:
    call enemy_patron_4;;aqui se llama a lo que hace el enemigo al completar su ciclo de movimiento
    call change_sprite_to_dir_shooter
ret
;---------------------------------:
;- IA del enemigo 4_Upgraded-:
;- Esta quieto y dispara-;
;---------------------------------;
enemy_ai_4_Upgraded:
    ld a, e_vidas(IX)
    dec a 
    jr nz, non_enraged_4
    enraged_4:
    call behaviour_shooter_search
    call change_sprite_to_dir_shooter_4
    jr fin_enemy_ai_4
    non_enraged_4:
    call enemy_patron_4;;aqui se llama a lo que hace el enemigo al completar su ciclo de movimiento
    call change_sprite_to_dir_shooter_2
    fin_enemy_ai_4:
ret
;---------------------------------:
;- IA del enemigo melee_search_1-:
;- Se mueve de lado a lado horzontalmente;
;- Si el jugador se situa en su x o en su y va a por el;
;---------------------------------;
enemy_ai_melee_search_1:
    call behaviour_horizontal_search
    call change_sprite_to_dir_melee_3
ret

;---------------------------------:
;- IA del enemigo melee_search_1_Upgraded-:
;- Se mueve de lado a lado horzontalmente y tiene mas vidas;
;- Si el jugador se situa en su x o en su y va a por el;
;---------------------------------;
enemy_ai_melee_search_1_Upgraded:
    call behaviour_horizontal_search
    call change_sprite_to_dir_melee_4
ret
;---------------------------------:
;- IA del enemigo melee_search_2-:
;- Se mueve de lado a lado verticalmente;
;- Si el jugador se situa en su x o en su y va a por el;
;---------------------------------;
enemy_ai_melee_search_2:
    call behaviour_vertical_search
    call change_sprite_to_dir_melee_3
ret
;---------------------------------:
;- IA del enemigo melee_search_2_Upgraded-:
;- Se mueve de lado a lado verticalmente y tiene mas vidas;
;- Si el jugador se situa en su x o en su y va a por el;
;---------------------------------;
enemy_ai_melee_search_2_Upgraded:
    call behaviour_vertical_search
    call change_sprite_to_dir_melee_4
ret
;---------------------------------:
;- IA del enemigo shooter_search-:
;- Esta quieto y dispara-;
;- Busca al enemigo para dispararle-;
;---------------------------------;
enemy_ai_shooter_search:
    call behaviour_shooter_search
    call change_sprite_to_dir_shooter_3
ret
;---------------------------------:
;- IA del enemigo shooter_search_Upgraded-:
;- Esta quieto y dispara-;
;- Busca al enemigo para dispararle-;
;---------------------------------;
enemy_ai_shooter_search_Upgraded:
    call behaviour_shooter_search
    call change_sprite_to_dir_shooter_4
ret
;---------------------------------:
;- IA del enemigo shootMove_v_right-:
;- Se mueve verticalmente y dispara hacia la derecha-;
;---------------------------------;
enemy_ai_shootMove_v_right:
    call behaviour_shootMove_v_right
    call change_sprite_to_dir_shooter
ret

;---------------------------------:
;- IA del enemigo shootMove_v_left-:
;- Se mueve verticalmente y dispara hacia la izquierda-;
;---------------------------------;
enemy_ai_shootMove_v_left:
    call behaviour_shootMove_v_left
    call change_sprite_to_dir_shooter
ret

;---------------------------------:
;- IA del enemigo shootMove_h_down-:
;- Se mueve horizontalmente y dispara hacia abajo-;
;---------------------------------;
enemy_ai_shootMove_h_down:
    call behaviour_shootMove_h_down
    call change_sprite_to_dir_shooter
ret

;---------------------------------:
;- IA del enemigo shootMove_h_up-:
;- Se mueve verticalmente y dispara hacia arriba-;
;---------------------------------;
enemy_ai_shootMove_h_up:
    call behaviour_shootMove_h_up
    call change_sprite_to_dir_shooter
ret
;---------------------------------:
;- IA del enemigo shootMove_patron_-1:
;- Se mueve en un patron de rectangulo segun las agujas del reloj-;
;---------------------------------;
enemy_ai_shootMove_patron_1:
    ld d, e_dir(IX)
    call behaviour_shooter_patron_search
    dec a 
    jr z, shooted_shootMove_patron_1
    call behaviour_shootMove_patron_1
    call change_sprite_to_dir_shooter_3
    jr fin_shootMove_patron_1
    shooted_shootMove_patron_1:
    call change_sprite_to_dir_shooter_3
    ld e_dir(IX), d
    fin_shootMove_patron_1:

    
ret

;---------------------------------:
;- IA del enemigo shootMove_patron_2-:
;- Se mueve en un patron de rectangulo al contrario de las agujas del reloj-;
;---------------------------------;
enemy_ai_shootMove_patron_2:
    ld d, e_dir(IX)
    call behaviour_shooter_patron_search
    dec a 
    jr z, shooted_shootMove_patron_2
    call behaviour_shootMove_patron_2
    call change_sprite_to_dir_shooter_3
    jr fin_shootMove_patron_2
    shooted_shootMove_patron_2:
    call change_sprite_to_dir_shooter_3
    ld e_dir(IX), d
    fin_shootMove_patron_2:
ret

;---------------------------------:
;- Listas de comportamientos a los que llaman las IAs-:
;---------------------------------;

behaviour_vertical:
    ld a, e_ai_c(IX) ;; aqui es donde guardas si ha completado su movimiento
    dec a
    jr nz, no_cambia_patron_behaviour_vertical
    call enemy_patron_3;;aqui se llama a lo que hace el enemigo al completar su ciclo de movimiento
    jr fin_enemy_behaviour_vertical
    no_cambia_patron_behaviour_vertical:
    call enemy_movement;;todos en principio llamaran a enemy movement porque lo que hace es mover el enemigo segun su direccion
    ;; y avisar de cuando ha completado su ciclo de movimiento
    fin_enemy_behaviour_vertical:
ret

behaviour_horizontal:
    ld a, e_ai_c(IX) ;; aqui es donde guardas si ha completado su movimiento
    dec a
    jr nz, no_cambia_patron_horizontal
    call enemy_patron_2;;aqui se llama a lo que hace el enemigo al completar su ciclo de movimiento
    jr fin_enemy_horizontal
    no_cambia_patron_horizontal:
    call enemy_movement;;todos en principio llamaran a enemy movement porque lo que hace es mover el enemigo segun su direccion
    ;; y avisar de cuando ha completado su ciclo de movimiento
    fin_enemy_horizontal:
ret

behaviour_horizontal_search:
    ld a, e_ai_c(IX) ;; aqui es donde guardas si ha completado su movimiento
    dec a
    jr nz, no_cambia_patron_horizontal_search
    call enemy_search_player
    dec a 
    jr z, melee_search_1
    call enemy_patron_2;;aqui se llama a lo que hace el enemigo al completar su ciclo de movimiento
    jr no_cambia_patron_horizontal_search
    melee_search_1:
    call enemy_patron_melee_finded
    no_cambia_patron_horizontal_search:
    call enemy_movement;;todos en principio llamaran a enemy movement porque lo que hace es mover el enemigo segun su direccion
    ;; y avisar de cuando ha completado su ciclo de movimiento
    fin_enemy_horizontal_search:
ret
behaviour_vertical_search:
    ld a, e_ai_c(IX) ;; aqui es donde guardas si ha completado su movimiento
    dec a
    jr nz, no_cambia_patron_vertical_search
    call enemy_search_player
    dec a 
    jr z, melee_search_2
    call enemy_patron_3;;aqui se llama a lo que hace el enemigo al completar su ciclo de movimientoenemy_search_player
    jr no_cambia_patron_vertical_search
    melee_search_2:
    call enemy_patron_melee_finded
    no_cambia_patron_vertical_search:
    call enemy_movement;;todos en principio llamaran a enemy movement porque lo que hace es mover el enemigo segun su direccion
    ;; y avisar de cuando ha completado su ciclo de movimiento
    fin_enemy_vertical_search:
ret

behaviour_shooter_search:
    call enemy_search_player
    dec a 
    jr nz, continue_shooter_search
    call enemy_patron_shooter_finded
    continue_shooter_search:
    call enemy_patron_4
ret

behaviour_shooter_patron_search:
    call enemy_search_player
    dec a 
    ld a, #0x02;;para la comprobacion de si esta disparando
    jr nz, fin_behaviour_shooter_patron_search
    call enemy_patron_shooter_finded
    call reinit_vel
    call enemy_patron_4 
    ld a, #0x01;;para la comprobacion de si esta disparando
    fin_behaviour_shooter_patron_search:
ret


behaviour_shootMove_v_right:
    ld a, e_dir(IX)
    dec a;;comprobamos que la dir es derecha
    jr z, interchange_dir_shootMove_v_right
    ld a, e_ai_c(IX)
    dec a
    jr nz, set_behaviour_shootMove_v_right
    call enemy_interchange_dir
    call enemy_patron_4
    jr fin_enemy_ai_shootMove_v_right
    interchange_dir_shootMove_v_right:
    call enemy_interchange_dir
    call enemy_patron_3
    ld a, #0x01
    ld e_shoot_c(IX), a
    set_behaviour_shootMove_v_right:
    call behaviour_vertical
    fin_enemy_ai_shootMove_v_right:
ret
behaviour_shootMove_v_left:
    ld a, e_dir(IX)
    ld b, #0x03;;comprobamos que la dir es izquierda
    sub b
    jr z, interchange_dir_shootMove_v_left
    ld a, e_ai_c(IX)
    dec a
    jr nz, set_behaviour_shootMove_v_left
    call enemy_interchange_dir
    call enemy_patron_4
    jr fin_enemy_ai_shootMove_v_left
    interchange_dir_shootMove_v_left:
    call enemy_interchange_dir
    call enemy_patron_3
    ld a, #0x01
    ld e_shoot_c(IX), a
    set_behaviour_shootMove_v_left:
    call behaviour_vertical
    fin_enemy_ai_shootMove_v_left:
ret
behaviour_shootMove_h_down:
    ld a, e_dir(IX)
    ld b, #0x02;;comprobamos que la dir es abajo
    sub b
    jr z, interchange_dir_shootMove_h_down
    ld a, e_ai_c(IX)
    dec a
    jr nz, set_behaviour_shootMove_h_down
    call enemy_interchange_dir
    call enemy_patron_4
    jr fin_enemy_ai_shootMove_h_down
    interchange_dir_shootMove_h_down:
    call enemy_interchange_dir
    call enemy_patron_2
    ld a, #0x01
    ld e_shoot_c(IX), a
    set_behaviour_shootMove_h_down:
    call behaviour_horizontal
    fin_enemy_ai_shootMove_h_down:
ret
behaviour_shootMove_h_up:
    ld a, e_dir(IX)
    ld b, #0x04;;comprobamos que la dir es arriba
    sub b
    jr z, interchange_dir_shootMove_h_up
    ld a, e_ai_c(IX)
    dec a
    jr nz, set_behaviour_shootMove_h_up
    call enemy_interchange_dir
    call enemy_patron_4
    jr fin_enemy_ai_shootMove_h_up
    interchange_dir_shootMove_h_up:
    call enemy_interchange_dir
    call enemy_patron_2
    ld a, #0x01
    ld e_shoot_c(IX), a
    set_behaviour_shootMove_h_up:
    call behaviour_horizontal
    fin_enemy_ai_shootMove_h_up:
ret

behaviour_shootMove_patron_1:
    ld a, e_ai_c(IX) ;; aqui es donde guardas si ha completado su movimiento
    dec a
    jr nz, no_cambia_shootMove_patron_1
    call enemy_patron_rectangle_1;;aqui se llama a lo que hace el enemigo al completar su ciclo de movimiento
    jr fin_enemy_shootMove_patron_1
    no_cambia_shootMove_patron_1:
    call enemy_movement;;todos en principio llamaran a enemy movement porque lo que hace es mover el enemigo segun su direccion
    ;; y avisar de cuando ha completado su ciclo de movimiento
    fin_enemy_shootMove_patron_1:
    ld a, #0x03
    ld e_shoot_c(IX), a
ret

behaviour_shootMove_patron_2:
    ld a, e_ai_c(IX) ;; aqui es donde guardas si ha completado su movimiento
    dec a
    jr nz, no_cambia_shootMove_patron_2
    call enemy_patron_rectangle_2;;aqui se llama a lo que hace el enemigo al completar su ciclo de movimiento
    jr fin_enemy_shootMove_patron_2
    no_cambia_shootMove_patron_2:
    call enemy_movement;;todos en principio llamaran a enemy movement porque lo que hace es mover el enemigo segun su direccion
    ;; y avisar de cuando ha completado su ciclo de movimiento
    fin_enemy_shootMove_patron_2:
ret

;---------------------------------:
;-Busca si el enemigo puede ver al jugador en su x o en su y-:
;-Devuelve en a un 1 si lo ha encontrado y un 0 si no-:
;-Devuelve en b la direccion en la que esta el jugador-:
;---------------------------------;
enemy_search_player:
    ld IY, #_entities

    check_search_x1:;;comprueba si la parte izquierda del jugador esta dentro de la diferencia entre la izquierda y la derecha del enemigo
        ld a, e_x(IY)
        ld b, a 
        ld a, e_x(IX) ; la esquina izquierda del enemigo que tiene que ser menor que la izquierda del jugador
        ld c, b
        sub b
        jr nc, check_search_x2
        ld a, e_x(IX)
        ld b, a
        ld a, e_w(IX)
        dec a
        add b ;; en a la esquina derecha del enemigo que tiene que ser mayor que la izquierda del jugador
        ld b, c
        sub b
        jr nc, same_x
    check_search_x2:;;comprueba si la parte derecha del jugador esta dentro de la diferencia entre la izquierda y la derecha del enemigo
        ld a, e_x(IY)
        ld b, a 
            ld a, e_w(IY)
            dec a
            add b
            ld b, a
        ld a, e_x(IX) 
        ld c, b
        sub b
        jr nc, check_search_y1
        ld a, e_x(IX)
        ld b, a
        ld a, e_w(IX)
        dec a
        add b 
        ld b, c
        sub b
        jr nc, same_x


    check_search_y1:;;comprueba si la parte arriba del jugador esta dentro de la diferencia entre arriba y abajo del enemigo
        ld a, e_y(IY)
        ld b, a 
        ld a, e_y(IX)
        ld c, b
        sub b
        jr nc, check_search_y2
        ld a, e_y(IX)
        ld b, a
        ld a, e_h(IX)
        add b 
        ld b, c
        sub b
        jr nc, same_y
    check_search_y2:;;comprueba si la parte abajo del jugador esta dentro de la diferencia entre arriba y abajo del enemigo
        ld a, e_y(IY)
        ld b, a 
            ld a, e_h(IY)
            add b
            ld b, a
        ld a, e_y(IX)
        ld c, b
        sub b
        jr nc, enemy_dont_see_player
        ld a, e_y(IX)
        ld b, a
        ld a, e_h(IX)
        add b 
        ld b, c
        sub b
        jr nc, same_y
        jr enemy_dont_see_player

    same_x:
    ld a, e_y(IY)
    ld b, a
    ld a, e_y(IX)
    sub b; si hay carry es que el jugador esta abajo, si no hay es que el jugador esta arriba
    jr nc, player_is_up
    player_is_down:
    ld a, #0x01
    ld b, #0x02
    jr fin_enemy_search_player
    player_is_up:
    ld a, #0x01
    ld b, #0x04
    jr fin_enemy_search_player
    same_y:
    ld a, e_x(IY)
    ld b, a
    ld a, e_x(IX)
    sub b; si hay carry es que el jugador esta en la derecha, si no hay es que el jugador esta en la izquierda
    jr nc, player_is_left
    player_is_right:
    ld a, #0x01
    ld b, #0x01
    jr fin_enemy_search_player
    player_is_left:
    ld a, #0x01     
    ld b, #0x03
    jr fin_enemy_search_player
    enemy_dont_see_player:
    ld a, #0x00
    fin_enemy_search_player:
ret
;---------------------------------:
;- Patrones de los enemigos-:
;---------------------------------;
enemy_patron_2:
    call reinit_vel
    ld a, e_dir(IX)
    dec a
    jr z, cambia_a_izq1
    ; cambia a la derecha
    ld a, #0x01
    jr fin_patron_2

    cambia_a_izq1:
    ;cambia a la izquierda
    ld a, #0x03

    fin_patron_2:

    ld e_dir(IX), a
    ld a, #0x40; movimientos que hace antes de dejar de moverse
    ld e_ai_c(IX), a
ret

enemy_patron_3:
    call reinit_vel
    ld a, e_dir(IX)
    dec a
    dec a
    jr z, cambia_a_arr1
    ; cambia a la derecha
    ld a, #0x02
    jr fin_patron_3

    cambia_a_arr1:
    ;cambia a la izquierda
    ld a, #0x04

    fin_patron_3:

    ld e_dir(IX), a
    ld a, #0x60; movimientos que hace antes de dejar de moverse
    ld e_ai_c(IX), a
ret



;---------------------------------:
;- Hace que el enemigo dispare hacia donde mira-:
;- Este patron es especial porque sirve para cualquier direccion a la que mire el enemigo-:
;- Hace que siempre dispare cada 10 en hexadecimal, tenerlo en cuenta-:
;---------------------------------;
enemy_patron_4:
    ld a, e_shoot_c(IX)
    dec a
    jr nz ,no_dispara
    ;;;;SFX
    push IX
    ld l, #3    ;Number of instrument in sfx song, same as arkos tracker
    ld h, #10  ; volume 0=off 15=max
    ld e, #48;50   ;Note of the instrument 0-127
    ld d, #0  ;speed - 0=as originak 1 is fastest
    ld bc, #0000 ;inverted pitch 
    ld a, #2 ;Canal de audio 2= ambos
    call cpct_akp_SFXPlay_asm
    pop IX

    ;;;;Fin SFX
    ld hl, #template_enemy_shoot

    call disparar_arma
    ld a, #0x14
    no_dispara:
    ld e_shoot_c(IX), a
ret
;---------------------------------:
;- Hace que el enemigo vaya a donde esta el jugador-:+
;- Le llega la direccion por b-:
;---------------------------------;
enemy_patron_melee_finded:
    ld a, b
    ld e_dir(IX), a
    ld a, #0x20
    ld e_ai_c(IX), a
ret
;---------------------------------:
;- Hace que el enemigo mire a donde esta el jugador y le dispare-;
;- Le llega la direccion por b-:
;---------------------------------;
enemy_patron_shooter_finded:
    ld a, b
    ld e_dir(IX), a
    ld a, #0x01
    ld e_ai_c(IX), a
ret

;---------------------------------:
;- Rectangulo segun las agujas del reloj-;
;- Cambia su direccion por la direccion a la que tiene que moverse-:
;---------------------------------;
enemy_patron_rectangle_1:
    call reinit_vel
    ld a, e_ai_dir(IX)
    ld e_dir(IX), a
    inc a 
    ld c, a
    ld b, #0x05
    sub b
    ld a, c
    jr nz, fin_patron_rectangle_1
    ld a, #0x01
    fin_patron_rectangle_1:
    ld e_ai_dir(IX), a
    ld a, #0x10; movimientos que hace antes de dejar de moverse
    ld e_ai_c(IX), a
ret

;---------------------------------:
;- Rectangulo al contrario de las agujas del reloj-;
;- Cambia su direccion por la direccion a la que tiene que moverse-:
;---------------------------------;
enemy_patron_rectangle_2:
    call reinit_vel
    ld a, e_ai_dir(IX)
    ld e_dir(IX), a
    dec a 
    jr nz, fin_patron_rectangle_2
    ld a, #0x04
    fin_patron_rectangle_2:
    ld e_ai_dir(IX), a
    ld a, #0x10; movimientos que hace antes de dejar de moverse
    ld e_ai_c(IX), a
ret

;---------------------------------:
;- Calculos generales para varios los enemigos-:
;---------------------------------;
enemy_movement:
    ;;;El enemigo se mueve segun a donde esta mirando
    ld a, e_dir(IX); cargas en a la direccion 1 d, 2 aba, 3 i, 4arr
    dec a
    jr z, dir_right; si mira hacia la derecha 
    dec a
    jr z, dir_down; si mira hacia abajo 
    dec a
    jr z, dir_left; si mira hacia la izquierda
    dec a
    jr z, dir_up; si mira hacia arriba 


    dir_right:
        call reinit_vel
        ld e_vx(IX), #0x01
        jr check_out_of_boundings_x_Max
    dir_down:
        call reinit_vel
        ld e_vy(IX), #0x02
        jr check_out_of_boundings_y_Max
    dir_left:
        call reinit_vel
        ld e_vx(IX), #0xFF
        jr check_out_of_boundings_x_0
    dir_up:
        call reinit_vel
        ld e_vy(IX), #0xFE
        jr check_out_of_boundings_y_0

    check_out_of_boundings_x_0:
     ;;Comprobar si colisiona con los boundings para cambiar la direccion
        ld a, e_x(IX)
        ld b, #0x04
        sub b
        jr z, set_change_dir
        jr fin_enemy_ai_out_of_boundings
    check_out_of_boundings_y_0:
        ld a, e_y(IX)
        ld b, #0x08
        sub b
        jr z,  set_change_dir
        jr fin_enemy_ai_out_of_boundings
    check_out_of_boundings_x_Max:
        ;Calc max pos X and if the X of the entity is delete
        ld a, #60;esto deberia de ser 63 pero da error en las columnas pares/impares
        ld b, e_w(IX)
        sub b
        ld b, a
        ld a, e_x(IX)
        sub b
        ;Si la enemy llega al maximo en X la borra de la memoria
        jr z,  set_change_dir
        jr fin_enemy_ai_out_of_boundings
    check_out_of_boundings_y_Max:
        ld a, #127
        ld b, e_h(IX)
        sub b
        ld b, a
        ld a, e_y(IX)
        sub b
        ;Si la enemy llega al maximo en X la borra de la memoria
        jr z, set_change_dir
        jr fin_enemy_ai_out_of_boundings   


        ;;aqui acaba el movimiento propiamente dicho

    set_change_dir:
        ld a, #0x01
        ld e_ai_c(IX), a
        jr fin_enemy_ai_movement
    set_check_set_change_dir:
        ld a, #0x01
        ld e_ai_c(IX), a
        jr fin_enemy_ai_movement
    fin_enemy_ai_out_of_boundings:
        ld a, e_ai_c(IX)
        dec a
        jr z, set_check_set_change_dir
        ld e_ai_c(IX), a


    fin_enemy_ai_movement:
    
ret

;---------------------------------:
;-Intercambia la direccion del jugador con su direccion para realizar algo de la IA-:
;---------------------------------;
enemy_interchange_dir:
    ld a, e_dir(IX)
    ld b, a
    ld a, e_ai_dir(IX)
    ld e_dir(IX), a
    ld a, b
    ld e_ai_dir(IX), a
ret

;---------------------------------:
;- Cambia el sprite a la direccion a la que mira-:
;---------------------------------;
change_sprite_to_dir_melee_1:
    ld a, e_dir(IX); cargas en a la direccion 1 d, 2 aba, 3 i, 4arr
    dec a
    jr z, dir_sprite_right; si mira hacia la derecha 
    dec a
    jr z, dir_sprite_down; si mira hacia abajo 
    dec a
    jr z, dir_sprite_left; si mira hacia la izquierda
    dec a
    jr z, dir_sprite_up; si mira hacia arriba 
    dir_sprite_right:
        ld hl, #Sprite_enemy_right
        jr fin_change_sprite_to_dir_1
    dir_sprite_down:
        ld hl, #Sprite_enemy_down
        jr fin_change_sprite_to_dir_1
    dir_sprite_left:
        ld hl, #Sprite_enemy_left
        jr fin_change_sprite_to_dir_1
    dir_sprite_up:
        ld hl, #Sprite_enemy_up

    fin_change_sprite_to_dir_1:
        ld e_spr(IX), l 
        ld e_spr2(IX), h
ret


change_sprite_to_dir_melee_2:
    ld a, e_dir(IX); cargas en a la direccion 1 d, 2 aba, 3 i, 4arr
    dec a
    jr z, dir_sprite_right2; si mira hacia la derecha 
    dec a
    jr z, dir_sprite_down2; si mira hacia abajo 
    dec a
    jr z, dir_sprite_left2; si mira hacia la izquierda
    dec a
    jr z, dir_sprite_up2; si mira hacia arriba 
    dir_sprite_right2:
        ld hl, #Sprite_enemy_2_right
        jr fin_change_sprite_to_dir_2
    dir_sprite_down2:
        ld hl, #Sprite_enemy_2_down
        jr fin_change_sprite_to_dir_2
    dir_sprite_left2:
        ld hl, #Sprite_enemy_2_left
        jr fin_change_sprite_to_dir_2
    dir_sprite_up2:
        ld hl, #Sprite_enemy_2_up

    fin_change_sprite_to_dir_2:
        ld e_spr(IX), l 
        ld e_spr2(IX), h
ret

change_sprite_to_dir_melee_3:
    ld a, e_dir(IX); cargas en a la direccion 1 d, 2 aba, 3 i, 4arr
    dec a
    jr z, dir_sprite_right3; si mira hacia la derecha 
    dec a
    jr z, dir_sprite_down3; si mira hacia abajo 
    dec a
    jr z, dir_sprite_left3; si mira hacia la izquierda
    dec a
    jr z, dir_sprite_up3; si mira hacia arriba 
    dir_sprite_right3:
        ld hl, #Sprite_enemy_3_right
        jr fin_change_sprite_to_dir_3
    dir_sprite_down3:
        ld hl, #Sprite_enemy_3_down
        jr fin_change_sprite_to_dir_3
    dir_sprite_left3:
        ld hl, #Sprite_enemy_3_left
        jr fin_change_sprite_to_dir_3
    dir_sprite_up3:
        ld hl, #Sprite_enemy_3_up

    fin_change_sprite_to_dir_3:
        ld e_spr(IX), l 
        ld e_spr2(IX), h
ret
change_sprite_to_dir_melee_4:
    ld a, e_dir(IX); cargas en a la direccion 1 d, 2 aba, 3 i, 4arr
    dec a
    jr z, dir_sprite_right4; si mira hacia la derecha 
    dec a
    jr z, dir_sprite_down4; si mira hacia abajo 
    dec a
    jr z, dir_sprite_left4; si mira hacia la izquierda
    dec a
    jr z, dir_sprite_up4; si mira hacia arriba 
    dir_sprite_right4:
        ld hl, #Sprite_enemy_4_right
        jr fin_change_sprite_to_dir_4
    dir_sprite_down4:
        ld hl, #Sprite_enemy_4_down
        jr fin_change_sprite_to_dir_4
    dir_sprite_left4:
        ld hl, #Sprite_enemy_4_left
        jr fin_change_sprite_to_dir_4
    dir_sprite_up4:
        ld hl, #Sprite_enemy_4_up

    fin_change_sprite_to_dir_4:
        ld e_spr(IX), l 
        ld e_spr2(IX), h
ret

change_sprite_to_dir_shooter:
    ld a, e_dir(IX); cargas en a la direccion 1 d, 2 aba, 3 i, 4arr
    dec a
    jr z, dir_sprite_right_shooter; si mira hacia la derecha 
    dec a
    jr z, dir_sprite_down_shooter ;si mira hacia abajo 
    dec a
    jr z, dir_sprite_left_shooter; si mira hacia la izquierda
    dec a
    jr z, dir_sprite_up_shooter; si mira hacia arriba 
    dir_sprite_right_shooter:
        ld hl, #Sprite_enemy_shooter_right
        jr fin_change_sprite_to_dir_shooter
    dir_sprite_down_shooter:
        ld hl, #Sprite_enemy_shooter_down
        jr fin_change_sprite_to_dir_shooter
    dir_sprite_left_shooter:
        ld hl, #Sprite_enemy_shooter_left
        jr fin_change_sprite_to_dir_shooter
    dir_sprite_up_shooter:
        ld hl, #Sprite_enemy_shooter_up

    fin_change_sprite_to_dir_shooter:
        ld e_spr(IX), l 
        ld e_spr2(IX), h
ret
change_sprite_to_dir_shooter_2:
    ld a, e_dir(IX); cargas en a la direccion 1 d, 2 aba, 3 i, 4arr
    dec a
    jr z, dir_sprite_right_shooter_2; si mira hacia la derecha 
    dec a
    jr z, dir_sprite_down_shooter_2 ;si mira hacia abajo 
    dec a
    jr z, dir_sprite_left_shooter_2; si mira hacia la izquierda
    dec a
    jr z, dir_sprite_up_shooter_2; si mira hacia arriba 
    dir_sprite_right_shooter_2:
        ld hl, #Sprite_enemy_shooter_2_right
        jr fin_change_sprite_to_dir_shooter_2
    dir_sprite_down_shooter_2:
        ld hl, #Sprite_enemy_shooter_2_down
        jr fin_change_sprite_to_dir_shooter_2
    dir_sprite_left_shooter_2:
        ld hl, #Sprite_enemy_shooter_2_left
        jr fin_change_sprite_to_dir_shooter_2
    dir_sprite_up_shooter_2:
        ld hl, #Sprite_enemy_shooter_2_up

    fin_change_sprite_to_dir_shooter_2:
        ld e_spr(IX), l 
        ld e_spr2(IX), h
ret

change_sprite_to_dir_shooter_3:
    ld a, e_dir(IX); cargas en a la direccion 1 d, 2 aba, 3 i, 4arr
    dec a
    jr z, dir_sprite_right_shooter_3; si mira hacia la derecha 
    dec a
    jr z, dir_sprite_down_shooter_3 ;si mira hacia abajo 
    dec a
    jr z, dir_sprite_left_shooter_3; si mira hacia la izquierda
    dec a
    jr z, dir_sprite_up_shooter_3; si mira hacia arriba 
    dir_sprite_right_shooter_3:
        ld hl, #Sprite_enemy_shooter_3_right
        jr fin_change_sprite_to_dir_shooter_3
    dir_sprite_down_shooter_3:
        ld hl, #Sprite_enemy_shooter_3_down
        jr fin_change_sprite_to_dir_shooter_3
    dir_sprite_left_shooter_3:
        ld hl, #Sprite_enemy_shooter_3_left
        jr fin_change_sprite_to_dir_shooter_3
    dir_sprite_up_shooter_3:
        ld hl, #Sprite_enemy_shooter_3_up

    fin_change_sprite_to_dir_shooter_3:
        ld e_spr(IX), l 
        ld e_spr2(IX), h
ret

change_sprite_to_dir_shooter_4:
    ld a, e_dir(IX); cargas en a la direccion 1 d, 2 aba, 3 i, 4arr
    dec a
    jr z, dir_sprite_right_shooter_4; si mira hacia la derecha 
    dec a
    jr z, dir_sprite_down_shooter_4 ;si mira hacia abajo 
    dec a
    jr z, dir_sprite_left_shooter_4; si mira hacia la izquierda
    dec a
    jr z, dir_sprite_up_shooter_4; si mira hacia arriba 
    dir_sprite_right_shooter_4:
        ld hl, #Sprite_enemy_shooter_4_right
        jr fin_change_sprite_to_dir_shooter_4
    dir_sprite_down_shooter_4:
        ld hl, #Sprite_enemy_shooter_4_down
        jr fin_change_sprite_to_dir_shooter_4
    dir_sprite_left_shooter_4:
        ld hl, #Sprite_enemy_shooter_4_left
        jr fin_change_sprite_to_dir_shooter_4
    dir_sprite_up_shooter_4:
        ld hl, #Sprite_enemy_shooter_4_up

    fin_change_sprite_to_dir_shooter_4:
        ld e_spr(IX), l 
        ld e_spr2(IX), h
ret


change_sprite_to_dir_shield:
    ld a, e_dir(IX); cargas en a la direccion 1 d, 2 aba, 3 i, 4arr
    dec a
    jr z, dir_sprite_right_shield; si mira hacia la derecha 
    dec a
    jr z, dir_sprite_down_shield ;si mira hacia abajo 
    dec a
    jr z, dir_sprite_left_shield; si mira hacia la izquierda
    dec a
    jr z, dir_sprite_up_shield; si mira hacia arriba 
    dir_sprite_right_shield:
        ld hl, #Sprite_enemy_shield_right
        jr fin_change_sprite_to_dir_shield
    dir_sprite_down_shield:
        ld hl, #Sprite_enemy_shield_down
        jr fin_change_sprite_to_dir_shield
    dir_sprite_left_shield:
        ld hl, #Sprite_enemy_shield_left
        jr fin_change_sprite_to_dir_shield
    dir_sprite_up_shield:
        ld hl, #Sprite_enemy_shield_up

    fin_change_sprite_to_dir_shield:
        ld e_spr(IX), l 
        ld e_spr2(IX), h
ret