;Copyright 2020, SoftBytes
;This file is part of Liam's Awakening.
;
;   Liam's Awakening is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;   (at your option) any later version.
;
;   Liam's Awakening is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with Liam's Awakening.  If not, see https://www.gnu.org/licenses/.

.include "collider.h.s"
.include "../man/entities.h.s"
.include "cpctelera.h.s"

collider_pairs:
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ; Masc IX compare Type iY
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ld a, e_collides(IX)
    ld b, e_type(IY)
    and b
    ;;if 0, IX collides IY
    jr z, collides_IX_IY_Fail
        ;;Calculate COllisions, im gona cry
        call collision_calc

        or a
        jr z, collides_IX_IY_Fail
        call death_sound
        ld a, e_type(IX)
        ld b, #e_type_dead ;;ld b, #0x80
        add b
        jr c, no_act_type_2
        ld e_type(IX), a
        no_act_type_2:

    collides_IX_IY_Fail:
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ; Masc IY compare Type IX
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ld a, e_collides(IY)
    ld b, e_type(IX)
    and b
    ;;if 0, IX collides IY
    jr z, collides_IY_IX_Fail
        ;;Calculate COllisions, im gona cry
        call collision_calc

        or a
        jr z, collides_IY_IX_Fail
        ;----SFX
        ;Cambiamos IX e IY para los sonidos
        push IX
        push IY
        pop IX
        call death_sound
        push IX
        pop IY
        pop IX
        ;----SFX
        ld a, e_type(IY)
        ld b, #0x80
        add b
        jr c, no_act_type
        ld e_type(IY), a
        no_act_type:

    collides_IY_IX_Fail:    
ret

collision_calc:
    ;;;;;;;;;,
    ; Get the IX.x < IY.x + IY.w
    ld a, e_x(IY)
    ld b, e_w(IY)
    dec b
    add b
    ld b, e_x(IX)
    sub b
    jr c, colision_failed
    ; Si IX es menor deberia de dar carry
    ;;;;;;;;;;;
    ;Calc 2
    ;;;;;;;;;,
    ; Get the IX.x+IX.w > IY.x
    ld a, e_x(IX)
    ld b, e_w(IX)
    dec b
    add b
    ld b, e_x(IY)
    sub b
    jr c, colision_failed
    ; Si IX es menor deberia de dar carry
    ;;;;;;;;;;;
    ;calc 3
    ;;;;;;;;;,
    ; Get the IX.y < IY.y + IY.h
    ld a, e_y(IY)
    ld b, e_h(IY)
    dec b
    add b
    ld b, e_y(IX)
    sub b
    jr c, colision_failed
    ; Si IX es menor deberia de dar carry
    ;;;;;;;;;;;
    ;Calc 4
    ;;;;;;;;;,
    ; Get the IX.y+IX.h > IY.y
    ld a, e_y(IX)
    ld b, e_h(IX)
    dec b
    add b
    ld b, e_y(IY)
    sub b
    jr c, colision_failed
    ; Si IX es menor deberia de dar carry
    ;;;;;;;;;;;




    ld a, #0x01
    ret
    colision_failed:
    ld a, #0x00
ret

update_collider_all:
    ld hl, #collider_pairs
    ld b, #e_cmp_collider
    call apply_for_all_pairs
ret

death_sound:
    ld  a, e_type(IX)
    ld  b, #e_type_player
    and b                                   ;; and a, b

    jr z, non_player_sound  
    ;;SFX de morir player
        push IX
        ld l, #4;2    ;Number of instrument in sfx song, same as arkos tracker
        ld h, #12   ; volume 0=off 15=max
        ld e, #40;50   ;Note of the instrument 0-127
        ld d, #3  ;speed - 0=as originak 1 is fastest
        ld bc, #0000 ;inverted pitch 
        ld a, #2 ;Canal de audio 2= ambos
        call cpct_akp_SFXPlay_asm
        pop IX
    non_player_sound:

    ld  a, e_type(IX)
    ld  b, #e_type_enemy
    and b 
    jr z, non_enemy_sound

            ;;SFX de muerte enemigo
            push IX
            ld l, #1    ;Number of instrument in sfx song, same as arkos tracker
            ld h, #11   ; volume 0=off 15=max
            ld e, #33;50   ;Note of the instrument 0-127
            ld d, #0  ;speed - 0=as originak 1 is fastest
            ld bc, #0000 ;inverted pitch 
            ld a, #2 ;Canal de audio 2= ambos
            call cpct_akp_SFXPlay_asm
            pop IX
    non_enemy_sound:


    ld  a, e_type(IX)
    ld  b, #e_type_hyper_adrenaline
    and b 
    jr z, non_hyper_sound

            ;;SFX de muerte enemigo
            push IX
            ld l, #2    ;Number of instrument in sfx song, same as arkos tracker
            ld h, #11   ; volume 0=off 15=max
            ld e, #70;60;50   ;Note of the instrument 0-127
            ld d, #6;7  ;speed - 0=as originak 1 is fastest
            ld bc, #0000 ;inverted pitch 
            ld a, #2 ;Canal de audio 2= ambos
            call cpct_akp_SFXPlay_asm
            pop IX
    non_hyper_sound:

ret