;Copyright 2020, SoftBytes
;This file is part of Liam's Awakening.
;
;   Liam's Awakening is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;   (at your option) any later version.
;
;   Liam's Awakening is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with Liam's Awakening.  If not, see https://www.gnu.org/licenses/.

.include "physics.h.s"
.include "../man/entities.h.s"
.include "cpctelera.h.s"
.include "../man/maps.h.s"

col_x: .db 00
col_y: .db 00
collision_type: .db 00
update_collision::
    ;; tx = x/4
    ;; ty = y78
    ;; tw = tilemap-width = 16
    ;; p = tilemap + ty*tw +tx
    ld a, e_type(IX)
    ld (collision_type), a
    ;;check player movement
    ld a, e_dir(IX)
    ;; 1 = der
    dec a
    jr nz, non_right_col
        ;;Comprobar esquina arriba derecha
        call collision_right_up
        call check_corner_col
        or a
        jr z, non_up_col
        ;;Comprobar esquina abajo derecha
        call collision_right_down
        call check_corner_col

        jr non_up_col
    non_right_col:
    ;; 2 = abajo
    dec a
    jr nz, non_down_col
        ;;Comprobar esquina abajo izquierda
        call collision_left_down
        call check_corner_col
        or a
        jr z, non_up_col
        ;;Comprobar esquina abajo derecha
        call collision_right_down
        call check_corner_col

        jr non_up_col
    non_down_col:
    ;; 3 = izquierda
    dec a
    jr nz, non_left_col
        ;;Comprobar esquina arriba izquierda
        call collision_left_up
        call check_corner_col
        or a
        jr z, non_up_col
        ;;Comprobar esquina abajo izquierda
        call collision_left_down
        call check_corner_col

        jr non_up_col
    non_left_col:
    ;; 4 = arriba
    dec a
    jr nz, non_up_col
        ;;Comprobar esquina arriba izquierda
        call collision_left_up
        call check_corner_col
        or a
        jr z, non_up_col
        ;;Comprobar esquina arriba derecha
        call collision_right_up
        call check_corner_col

    non_up_col:

ret


collision_right_up:
    ld a, e_x(IX)
    ld b, e_w(IX)
    add b
    dec a
    ld (col_x), a
    ld a, e_y(IX)
    ld (col_y), a
ret

collision_left_up:
    ld a, e_x(IX)
    ld (col_x), a
    ld a, e_y(IX)
    ld (col_y), a
ret

collision_left_down:
    ld a, e_x(IX)
    ld (col_x), a
    ld a, e_y(IX)
    ld b, e_h(IX)
    add b
    ld (col_y), a
ret

collision_right_down:
    ld a, e_x(IX)
    ld b, e_w(IX)
    add b
    dec a
    ld (col_x), a
    ld a, e_y(IX)
    ld b, e_h(IX)
    add b
    ld (col_y), a
ret

check_corner_col:

    ;; A = y
    ld a, (col_y)
    srl a ;; |
    srl a ;; | a/8
    srl a ;; |
    ;; HL = A o ty
    ld h, #0
    ld l, a
    ;; HL = 2*HL
    add hl, hl ;; 2ty
    add hl, hl ;; 4ty
    add hl, hl ;; 8ty
    add hl, hl ;; 16ty

    ;; A = x
    ld a, (col_x)
    srl a ;; |
    srl a ;; | A= x/4


    ;; Macro de añadir a a hl copiada
        add   l         ;; [1] | L += A (add up Least Significant Bytes)
        ld    l, a      ;; [1] |
        adc   h         ;; [1] A' = H + L' + Carry (L' = L + A)
        sub   l         ;; [1] A' = H + Carry  (As we subtract L')
        ld    h, a      ;; [1] | H = A' = H + Carry, finally making HL = HL + A
    ;;Fin macro

    push hl  ;;Guardamos hl
    push IX

    ;;;Sacar tilemap del mapa actual
    ;ld a, (_id_mapa_actual)
    ;call search_map
    ;;;en hl el mapa
    ;push hl
    ;pop IX
    ;ld e, e_map_tile(IX)
    ;ld d, 1+e_map_tile(IX)
    ;;;Volvemos a extrar el ix y los calculos que llevabamos
    ld de, #0x0F00

    pop IX
    pop hl

    add hl,de


    ld a, (collision_type)
    ld b, #0b00001100
    and b
    jr nz, shoot_jumping
        ;Pared con vacio
        ld a, (hl)
        sub #0b00000100
        jr z, collided_wall
        ;Pared esquina izq con vacio
        ld a, (hl)
        sub #0b00001011
        jr z, collided_wall
        ;Pared esquina der con vacio
        ld a, (hl)
        sub #0b00001100
        jr z, collided_wall
        ;esquina der sup con vacio
        ld a, (hl)
        sub #0b00010011
        jr z, collided_wall
        ;Esquina izq inf con vacio
        ld a, (hl)
        sub #0b00010100
        jr z, collided_wall
        ;Esquina izq sup con vacio
        ld a, (hl)
        sub #0b00000101
        jr z, collided_wall
        ;Esquina der inf con vacio
        ld a, (hl)
        sub #0b00010111
        jr z, collided_wall
        ;Borde sup con vacio
        ld a, (hl)
        sub #0b00000110
        jr z, collided_wall
        ;Borde inf con vacio
        ld a, (hl)
        sub #0b00010110
        jr z, collided_wall
        ;Borde der con vacio
        ld a, (hl)
        sub #0b00001111
        jr z, collided_wall
        ;Borde izq con vacio
        ld a, (hl)
        sub #0b00001101
        jr z, collided_wall
        ;Borde vacio con vacio
        ld a, (hl)
        sub #0b00001110
        jr z, collided_wall



    shoot_jumping:


    ld a, (collision_type)
    ld b, #0b00000010
    and b
    jr z, enemy_jumping 
        ;placa marcadora enemigo
        ld a, (hl)
        sub #0b00001010
        jr z, collided_wall
    enemy_jumping:
    ;;HL = tilemap + ty*tw+ tx
    ;muro
    ld a, (hl)
    sub #0b00001000
    jr z, collided_wall
    ;muro con borde
    ld a, (hl)
    sub #0b00000001
    ret nz
    collided_wall:
        ld a, e_x(IX)
        ld b, e_vx(IX)
        sub b
        ld e_x(IX), a
        ld a, e_y(IX)
        ld b, e_vy(IX)
        sub b
        ld e_y(IX), a
        ;; Si es una bala se va fuera
        ld a, e_type(IX)
        ld b, #0b00001100
        and b
        jr z, final_corner_col
            ld a, e_type(IX)
            ld b, #0x80
            add b
            ld e_type(IX), a
        jr final_corner_col
        final_corner_col:
        ld a, #0
        ld b, #0x01
        ld e_ai_c(IX), b
ret




update_collision_all::
    ld hl, #update_collision
    ld b, #e_cmp_colision
    call apply_for_all
ret