;Copyright 2020, SoftBytes
;This file is part of Liam's Awakening.
;
;   Liam's Awakening is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;   (at your option) any later version.
;
;   Liam's Awakening is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with Liam's Awakening.  If not, see https://www.gnu.org/licenses/.

.include "physics.h.s"
.include "../man/game.h.s"
.include "../man/entities.h.s"
;.include "../man/interruptions.h.s"
.include "cpctelera.h.s"
.include "../sprites/sprites.h.s"
.include "../templates/templates.h.s"
;Hay que crear la bala en las entidades creando un generador de entidades :)
.include "ai.h.s"

_reserved_shoot_x:: .db 0x00
_reserved_shoot_y:: .db 00
_reserved_shoot_vx:: .db 0x00
_reserved_shoot_vy:: .db 00
_reserved_IX:: .dw 0000
_reserved_dir:: .db 00
_dir_salida:: .db 00
_muted_soon:: .db 01

;.globl cpct_scanKeyboard_f_asm
.globl cpct_isKeyPressed_asm
.globl cpct_akp_stop_asm
.globl cpct_akp_SFXPlay_asm

check_keyboard: ;Si es jugable mira el call
    ld a, #0x00
    ld e_vx(IX) ,a
    ld e_vy(IX) ,a
    
    ;Cheat mode inc lvl
    ;ld hl, #0x4005
    ;call cpct_isKeyPressed_asm
    ;or a
    ;jr z,  no_inc_level_cheat
    ;    ld a, (hyperadrenaline)
    ;    inc a
    ;    ld (hyperadrenaline), a
    ;    ld a, #1
    ;    ld (death_counter), a
    ;no_inc_level_cheat:
    
    ;call cpct_scanKeyboard_f_asm

    ;;Tecla M para entrar al mute
        ld a, (_muted_soon)
        dec a
        ld (_muted_soon), a
        jr nz, no_escape_from_music
            inc a
            ld (_muted_soon), a
            ld hl, #0x4004
        call cpct_isKeyPressed_asm
        or a
        jr z, no_escape_from_music
        ld a, #6
        ld (_muted_soon), a
        ld a,(man_mute_music)
        dec a
        ld (man_mute_music), a
        jr z, no_escape_from_music
        ld a,#1
        ld (man_mute_music), a
        call cpct_akp_stop_asm

    no_escape_from_music:
    ;;Mira si el jugador ha pulsado el escape para salir
        ld hl, #0x0408
        call cpct_isKeyPressed_asm
        or a
        jr z, no_escape_from_fys
            ld a, #01
            ld (pause_pressed),a


    no_escape_from_fys:
    ;;Fin escape
    ld hl, #0x0409 ;Joystick_left_control
    call cpct_isKeyPressed_asm
    or a
    jr nz, joystick_left_control

    ld hl, #0x0404 ;Tecla O
    call cpct_isKeyPressed_asm
    or a
    jr z, sig_tecla_1
    joystick_left_control:

    ;izquierda
    ld hl, #Sprite_jugador_left
    ld e_spr(IX), l 
    ld e_spr2(IX), h

    ld e_dir(IX), #0x03
    
    ld a, #p_vel_x_neg
     ld e_vx(IX), a

    sig_tecla_1:


    ld hl, #0x0809 ;Joystick_left_control
    call cpct_isKeyPressed_asm
    or a
    jr nz, joystick_right_control

    ld hl, #0x0803  ;Tecla P
    call cpct_isKeyPressed_asm
    or a
    jr z, sig_tecla_2
    joystick_right_control:

    ;derecha
    ld hl, #Sprite_jugador_right
    ld e_spr(IX), l 
    ld e_spr2(IX), h

    ld e_dir(IX), #0x01

    ld a, #p_vel_x_pos;tecla d
     ld e_vx(IX), a

    sig_tecla_2:
    

    ld hl, #0x0109 ;Joystick_up_control
    call cpct_isKeyPressed_asm
    or a
    jr nz, joystick_up_control

    ld hl, #0x0808  ;Tecla Q
    call cpct_isKeyPressed_asm
    or a
    jr z, sig_tecla_3
    joystick_up_control:

    ;arriba
    ld hl, #Sprite_jugador_up
    ld e_spr(IX), l 
    ld e_spr2(IX), h

    ld e_dir(IX), #0x04

    ld a, #p_vel_y_neg
     ld e_vy(IX), a
     ld e_vx(IX), #0
    sig_tecla_3:
    ld hl, #0x0209 ;Joystick_down_control
    call cpct_isKeyPressed_asm
    or a
    jr nz, joystick_down_control

    ld hl, #0x2008 ;Tecla A
    call cpct_isKeyPressed_asm
    or a
    jr z, sig_tecla_4
    joystick_down_control:

    ;abajo
    ld hl, #Sprite_jugador_down
    ld e_spr(IX), l 
    ld e_spr2(IX), h

    ld e_dir(IX), #0x02

    ld a, #p_vel_y_pos
     ld e_vy(IX), a
     ld e_vx(IX), #0
    sig_tecla_4:


    ;Tecla Espacio para disparar
    ld a, e_shoot_c(IX)
    dec a
    ld e_shoot_c(IX), a
    jr nz ,sig_tecla_5
    ld a, #0x01
    ld e_shoot_c(IX), a

    ld hl, #0x1009 ;Joystick_shoot1_control
    call cpct_isKeyPressed_asm
    or a
    jr nz, joystick_shot_control
    ld hl, #0x2009 ;Joystick_shoot1_control
    call cpct_isKeyPressed_asm
    or a
    jr nz, joystick_shot_control
    ld hl, #0x8005 
    call cpct_isKeyPressed_asm
    or a
    jr z, sig_tecla_5
    joystick_shot_control:


    ;Llamar a la funcion que crea las balas
    
    ld a, #0x0C
    ld e_shoot_c(IX), a
    ld hl, #template_shoot
    call disparar_arma


    ;;SFX del disparo
    push IX
    ld l, #3    ;Number of instrument in sfx song, same as arkos tracker
    ld h, #10   ; volume 0=off 15=max
    ld e, #53;50   ;Note of the instrument 0-127
    ld d, #0  ;speed - 0=as originak 1 is fastest
    ld bc, #0000 ;inverted pitch 
    ld a, #2 ;Canal de audio 2= ambos
    call cpct_akp_SFXPlay_asm
    pop IX

    sig_tecla_5:

ret

disparar_arma:

    ld a, #0x00
    ld (_reserved_shoot_vy), a
    ld (_reserved_shoot_vx), a
    ld a, e_dir(IX)
    dec a
    jr z, disparo_derecha
    dec a
    jr z, disparo_abajo
    dec a
    jr z, disparo_izquierda
    dec a
    jr z, disparo_arriba
    ;Default(Sin hacer)
    jp finalizar_disparos
    
    disparo_derecha:
        ;Reservar Velocidades
        ld a, #b_vel_x_pos
        ld (_reserved_shoot_vx), a
        ;Sacamos la posicion en X
        ld a, e_x(IX)
        ;ld b, e_w(IX)
        ;add b
        inc a   ;Uno mas para el pixel vacio
        ld (_reserved_shoot_x),a
        ;Sacamos la posicion en Y
        ld a, e_h(IX)
        rra
        and #0b01111111
        ld b,a
        ld a, e_y(IX)
        ;dividimos entre 2 b
        add b
        ld b, #0x01;;la mitad del tamanyo de la bala, lo hardcodeamos para evitar otra division mas
        sub b
        ld (_reserved_shoot_y),a
        ;Habria que crear el sprite
        jr finalizar_disparos
    disparo_abajo:

        ;Reservar Velocidades
        ld a, #b_vel_y_pos
        ld (_reserved_shoot_vy), a
        ;Sacamos la posicion en X
        ld a, e_y(IX)
        ;ld b, e_h(IX)
        ;add b
        inc a;Uno mas para el pixel vacio
        ld (_reserved_shoot_y),a
        ;Sacamos la posicion en Y
        ld a, e_w(IX)
        rra
        and #0b01111111
        ld b,a
        ld a, e_x(IX)
        ;dividimos entre 2 b
        add b
        ld b, #0x00
        ;ld b, #0x01;;la mitad del tamanyo de la bala, lo hardcodeamos para evitar otra division mas
        sub b
        ld (_reserved_shoot_x),a
        ;Habria que crear el sprite
        jr finalizar_disparos

    disparo_izquierda:
        ;Reservar Velocidades
        ld a, #b_vel_x_neg
        ld (_reserved_shoot_vx), a
        ;Sacamos la posicion en X
        ld a, e_x(IX)
        ld b, e_w(IX)
        dec b
        add b
        dec a;Uno mas para el pixel vacio
        ld (_reserved_shoot_x),a
        ;Sacamos la posicion en Y
        ld a, e_h(IX)
        rra
        and #0b01111111
        ld b,a
        ld a, e_y(IX)
        ;dividimos entre 2 b
        add b
        ld b, #0x01;;la mitad del tamanyo de la bala, lo hardcodeamos para evitar otra division mas
        sub b
        ld (_reserved_shoot_y),a
        ;Habria que crear el sprite
        jr finalizar_disparos

    disparo_arriba:

        ;Reservar Velocidades
        ld a, #b_vel_y_neg
        ld (_reserved_shoot_vy), a
        ;Sacamos la posicion en X
        ld a, e_y(IX)
        ld b, e_h(IX)
        dec b
        dec b
        dec b 
        dec b
        add b
        ld (_reserved_shoot_y),a
        dec a ;Uno mas para el pixel vacio
        ;Sacamos la posicion en Y
        ld a, e_w(IX)
        rra
        and #0b01111111
        ld b,a
        ld a, e_x(IX)
        ;dividimos entre 2 b
        add b
        ld b, #0x00;;la mitad del tamanyo de la bala, lo hardcodeamos para evitar otra division mas
        sub b
        ld (_reserved_shoot_x),a
        ;Habria que crear el sprite

    finalizar_disparos:

    ld (_reserved_IX) , IX
    ld a, e_dir(IX)
    ld (_reserved_dir),a
    call create_one_entity

    ;De momento el disparo sale un pelin desplazado porque
    ;como aún no hemos creado un sistema de borrado tiene bordes
    ;se solucionará solo cuando los sprites sean completos
    ;Disparo
    ld a, (_reserved_shoot_x)
    ld e_x(IX), a
    ld a, (_reserved_shoot_y)
    ld e_y(IX), a
    ld a, (_reserved_shoot_vx)
    ld e_vx(IX), a
    ld a, (_reserved_shoot_vy)
    ld e_vy(IX), a
    ld a, (_reserved_dir)
    ld e_dir(IX), a

    ;La bala es un cuadrado, si hay que darle sprite segun direccion habria que hacerlo aqui

    ld IX , (_reserved_IX)

ret

update_physics: ;Actualiza posicion, utiliza _dir_salida para saber si el jugador se ha salido y por donde

    ; si es el jugador poner la direccion de salida a 0
    ld a, e_type(IX)
    dec a
    jr nz, begin_update_physics
        ld a, #0x00
        ld (_dir_salida), a
    begin_update_physics:
    ld a, e_comp(IX)
    ld b, #e_cmp_input
    and b
    sub b
    jr nz, start_physics
    call check_keyboard

    start_physics:
    ;El apartado de velocidad X
    ld a, e_vx(IX)
    ld b, #0x80 ;Complemento a 2, mira si es negativo o positivo
    add a, b
    jr c, mov_neg

    ;Guardamos en C las variables "maximas" de cada lado
        ld c, #max_x
        ld a, c
        ld c, e_w(IX)
        sub c
        ld c,a
            ;le sumas a x su velocidad
            ld a, e_x(IX)
            ld b, e_vx(IX)
            add a, b
            ld e_x(IX),a
            ;Comprobar que no se ha pasado del maximo de pantalla
            ld a, #256-64+1
            ld b, e_w(IX)
            add a,b
            ld b,a
            ld  a, e_x(IX)
            add a,b
            jr nc, calculate_y_phys
            ld a, c ;Si hay carry lo capas en C
            ld e_x(IX), a

            ; cargamos el token de comprobar el mapa
            ld a, e_type(IX)
            dec a
            jr nz, calculate_y_phys
            ld a, #0x01
            ld (_dir_salida), a

            jr calculate_y_phys
        mov_neg:
        ld c, #min_x
            ;le sumas a x su velocidad
            ld a, e_x(IX)
            ld b, e_vx(IX)
            add a, b
            ld e_x(IX),a
            ;Comprobar que no se ha pasado del maximo de pantalla
            ld a, e_x(IX)
            sub c
            jr nc, calculate_y_phys
            ld a, c ;Si hay carry lo capas en C
            ld e_x(IX), a
            ; cargamos el token de comprobar el mapa
            ld a, e_type(IX)
            dec a
            jr nz, calculate_y_phys
            ld a, #0x03
            ld (_dir_salida), a
   

    calculate_y_phys:

    ld a, e_vy(IX)
    ld b, #0x80
    add a, b
    jr c, mov_y_neg
    ld c, #max_y ;Y maxima
    ld a, c
    ld c, e_h(IX)
    sub c
    ld c,a
    
        ld a, e_y(IX)
        ld b, e_vy(IX)
        add a, b
        ld e_y(IX),a
        ;Comprobar que no se ha pasado del maximo de pantalla
        ld a, #256-127+1
        ld b, e_h(IX)
        add a,b
        ld b,a
        ld  a, e_y(IX)
        add a,b
        jr nc, finish
        ld a, c
        ld e_y(IX), a

        ; cargamos el token de comprobar el mapa
        ld a, e_type(IX)
        dec a
        jr nz, finish
        ld a, #0x02
        ld (_dir_salida), a
        jr finish
    mov_y_neg:
        ld c, #min_y;Y min
        ld a, e_y(IX)
        ld b, e_vy(IX)
        add a, b
        ld e_y(IX),a
        ;Comprobar que no se ha pasado del maximo de pantalla
        ld a, e_y(IX)
        sub c
        jr nc, finish
        ld a, c
        ld e_y(IX), a

        ; cargamos el token de comprobar el mapa
        ld a, e_type(IX)
        dec a
        jr nz, finish
        ld a, #0x04
        ld (_dir_salida), a
    finish:
ret

update_physics_all:
    ld hl, #update_physics
    ld b, #e_cmp_movable
    call apply_for_all
ret