;Copyright 2020, SoftBytes
;This file is part of Liam's Awakening.
;
;   Liam's Awakening is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;   (at your option) any later version.
;
;   Liam's Awakening is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with Liam's Awakening.  If not, see https://www.gnu.org/licenses/.

.include "render.h.s"
.include "../man/entities.h.s"
.include "cpctelera.h.s"
.include "cpct_changed.h.s"
.include "../sprites/sprites.h.s"
.include "../man/game.h.s"
.include "../man/maps.h.s"
;.include "../../c_sprites/g_"

.globl cpct_drawSprite_asm
.globl cpct_getScreenPtr_asm
.globl cpct_drawSolidBox_asm
.globl cpct_setVideoMode_asm
.globl cpct_setPALColour_asm
.globl cpct_setPalette_asm
.globl set_crtc
.globl _tileset_buena_00
.globl _g_palette


helper_life_counter:: .db #0x00
helper_life:: .db #0x00
helper_life_pos_x:: .db #0x00


update_render: ;Renderiza posicion
    ;----------------------------
    ;Borrado del SPrite anterior
    ;----------------------------------
    ;Borra anterior sprite
    ;ld l, e_last_mem_pos2(IX)
    ;ld h, 1+e_last_mem_pos2(IX)
    ;ld bc, #0x0000
    ;adc hl, bc
;
    ;jr z, is_first_time
    ;comprobar si es 1ra it
    ;ex de, hl
    ;ld b, e_h(IX)
    ;ld c, e_w(IX)
    ;ld a, #0x00 ;00 para borrar
    ;call changed_cpct_drawSolidBox_32x16

    ;is_first_time:

    ;-------------------
    ;Dibujo Nuevo Sprite
    ;-------------------

    back_buffer= . + 2
    ld   de, #0xC400 ;Principio de pantalla
    ld   c, e_x(IX)
    ld   b, e_y(IX)
    call changed_cpct_getScreenPtr_32x16

    
; Descomentar si ponemos borrado anterior
    ;ld a, e_last_mem_pos(IX)
    ;ld e_last_mem_pos2(IX), a
    ;ld a, 1+e_last_mem_pos(IX)
    ;ld 1+e_last_mem_pos2(IX), a
;
    ;ld e_last_mem_pos(IX), l
    ;ld 1+e_last_mem_pos(IX), h

    ;Cargar en DE donde empieza
    ex de, hl

    ;si esta muerto pa borrar
    ld a, e_type(IX)
    ld b, #0x80
    and b ;1000 0000
    jr nz, finalizar_el_update

    ;Sacar posicion de memoria del sprite
    ld l, e_spr(IX)
    ld h, e_spr2(IX)

    ;Height y width  
    ld b, e_h(IX)
    ld c, e_w(IX)
    call changed_cpct_drawSprite_32x16
    ;11001100
    finalizar_el_update:

ret

update_render_all:
    ld hl, #update_render
    ld b, #e_cmp_render
    call apply_for_all

    call change_screen
ret




render_set_video_mode:
;Set video mode to mode 0 (more colours less pixels)
ld c, #0x00
call cpct_setVideoMode_asm


    ld hl , #_g_palette
    ld de, #0x10
    call cpct_setPalette_asm

;Border Color
   ld l, #0x10
   ld h, #0x14
   call cpct_setPALColour_asm

;; Change Screen size: 32x16
    ;;R1 = Width - 0120 
    ld de, #0x0120
    call render_CRTC

    ld de, #0x022A
    call render_CRTC

    ;;R6 = height 0610
    ld de, #0x0610
    call render_CRTC
    ;;
    ld de, #0x071A
    call render_CRTC

ret

;----------------------------;
; Clear entity 2 Screen
; Input:
;
;
;
;----------------------------;
clear_entity_2_screen:

ret

clear_all_entities:

    ;ld  IX, #_entities
    ;ld  bc, #e_size
    ;ld  d, #e_max_entities
;
    ;clear_all_loop:
    ;    push bc
    ;    push de
    ;    call clear_entity_2_screen
    ;    pop de
    ;    pop bc
    ;    add IX, bc          ;; Salta a la siguiente
    ;    dec d
    ;    jr nz, clear_all_loop
ret

;----------------------------;
; Change CRTC
; Input: 
;   D with register number
;   E with value   
; Output:
;   Destroy BC
;----------------------------;
;; 0x0120 = DE
render_CRTC:
    ld bc, #0xBC01
    out (c), d
    inc b
    out (c), e
ret

change_screen:
f_change_screen = . +1
    jp change_screen_to_C400

change_screen_to_C400:
    ld de, #0x0C32
    call set_crtc

    ld a, #0xC0
    ld (back_buffer), a

    ld hl, #change_screen_to_C000
    ld (f_change_screen), hl

ret

change_screen_to_C000:


    ld de, #0x0C30
    call set_crtc

    ld a, #0xC4
    ld (back_buffer), a

    ld hl, #change_screen_to_C400
    ld (f_change_screen), hl

ret

set_crtc:
    ld bc, #0xBC00
    out (c), d
    inc b 
    out (c), e
ret



;Dibujar los corazones segun las vidas que le falten
render_my_life:

    ld  a, #0x05
    ld (helper_life_counter), a
    ld a, #0x00
    ld (helper_life_pos_x),a
    ld  a, (vidas)


    loop_draw_lives:
    ;Si a es distinto a 0 dibujamos marron

    inc a
    dec a
    ld (helper_life), a
    jr z , no_life_yet
    dec a

        ld (helper_life), a
        
        ld a, (back_buffer)
        ld d,a
        ld a, (back_buffer-1)
        ld e,a

        ld a, (helper_life_pos_x)
        ld   c, a
        ld   b, #0x00
        call changed_cpct_getScreenPtr_32x16

        ;Cargar en DE donde empieza
        ex de, hl

        ld hl, #Sprite_Full_Heart

        ;Height y width  
        ld b, #0x06
        ld c, #0x04
        call changed_cpct_drawSprite_32x16;

        jr finished_draw_1_heart
    no_life_yet:
        ld a, (back_buffer)
        ld d,a
        ld a, (back_buffer-1)
        ld e,a ;Principio de pantalla

        ld a, (helper_life_pos_x)
        ld   c, a
        ld   b, #0x00
        call changed_cpct_getScreenPtr_32x16

        ;Cargar en DE donde empieza
        ex de, hl

        ld hl, #Sprite_Empty_Heart

        ;Height y width  
        ld b, #0x06
        ld c, #0x04
        call changed_cpct_drawSprite_32x16


    finished_draw_1_heart:
    ld a,(helper_life_pos_x)
    ld b, #0x05
    add b
    ld (helper_life_pos_x),a

    ld a, (helper_life_counter)
    dec a
    ld (helper_life_counter), a
    ld b,a
    ld a, (helper_life)
    inc b
    dec b

    jp nz, loop_draw_lives


    ;;render hyperadrenaline gris
    ;ld b, #0x08
    ;ld c, #0x00
    ;ld a, (back_buffer)
    ;ld d,a
    ;ld a, (back_buffer-1)
    ;ld e,a
    ;call changed_cpct_getScreenPtr_32x16
    ;ex de, hl
    ;ld hl, #Sprite_Hyper_Adrenaline_Muro_Vacio
    ;;Height y width  
    ;ld b, #0x08
    ;ld c, #0x04
    ;call changed_cpct_drawSprite_32x16

ret


;---------------------------------:
;- Dibujado de Mapa -:
;- Coge el tilemap del mapa seleccionado y lo carga -;
;---------------------------------;
draw_tilemap::
;;Cargar direccion de memoria de la tile

    ;ld a, (_id_mapa_actual)
    ;call search_map
    ;push hl
    ;pop IX
    ;ld a, e_map_tile(IX)
    ;ld e, a
    ;ld a, 1+e_map_tile(IX)
    ;ld d,a
    ld de, #0xF00
    ;;Descomprimimos el mapa

    ld a, (back_buffer)
    ld h,a
    ld a, (back_buffer-1)
    ld l,a
    call DrawTileMap4x8_ag_32x16_asm
    ;;Segunda llamada a la otra mitad

    ld de, #0xF08
    ;;Descomprimimos el mapa

    ld a, (back_buffer)
    ld h,a
    ld a, (back_buffer-1)
    ld l,a
    ld bc,#32
    add hl,  bc
    call DrawTileMap4x8_ag_32x16_asm



ret

set_tileset::

    ;Anchura y altura del mapa
    ld c, #8 ;We need 2 renders but this is more accesible for interupts
    ld b, #16

    ld de, #0x0010
    ld hl, #_tileset_buena_00
    call setDrawTileMap4x8_ag_32x16_asm

ret


;Update de los tiles alrededor de las posiciones contiguas del jugador
update_tile::
;
;(1B C) x	x tile-coordinate of the starting tile inside the tilemap
;(1B B) y	y tile-coordinate of the starting tile inside the tilemap
;(1B E) w	width in tiles of the tile-box to be redrawn
;(1B D) h	height in tiles of the tile-box to be redrawn
;(1B A) map_width	Width in tiles of a complete row of the tilemap
;
;    ld a, e_x(IX)
;    ld b, e_vx(IX)
;    sub b
;    ld c, a ;X abteruir
;    ld a, e_y(IX)
;    ld b, e_vy(IX)
;    sub b
;    ld b,a ;Y a atribuir
;    ld e,#4
;    ld d,#4
;

ret

update_tile_all::
    ld hl, #update_tile
    ld b, #e_cmp_render
    call apply_for_all
ret

render_decrunched_image::
    ;Donde queremos copiar
    ld hl, #0x9000 ; ->E400
    ;; Cargamos el buffer actual
    ld a, (back_buffer)
    ld d,a
    ld a, (back_buffer-1)
    ld e,a
    ;DE C000->C400
    ld a, #16
    loop_pantalla_reintegrada: ;Repetir 16 veces
    ld bc, #0x0040

    ldir 
    
    push af
    ld a, #7
    loop_linea:

        ex de, hl
        ld bc, #0x07C0 ;800 -40 en hexa
        add hl, bc
        ld bc, #0x0040
        ex de,hl
        ldir
        dec a
    jr nz, loop_linea
    pop af
    ;-----;
    ;-Posiciona de en la siguiente pos memoria-;
        push af

        ld b,a
        ld a, #17
        sub b
        ld b,a

        ld a, (back_buffer)
        ld d,a
        ld a, (back_buffer-1)
        ld e,a

        ld a,b
        ld bc, #0x0040
        ex de,hl
        veces_que_hay_que_sumarle_cuarenta:
            add hl,bc
            dec a
        jr nz, veces_que_hay_que_sumarle_cuarenta
        ex de, hl
        pop af
    dec a
    jr nz, loop_pantalla_reintegrada

    ;Anotacion -> de final de  8va rep
    ;             le sumas 980 (lo que le falta para subir a 00)
    ;             +C000 para posicionarlo al principio
    ;             +40 = C9C0
    ;ex de, hl
    ;ld bc, #0x07C0 ;800 -40 en hexa
    ;add hl, bc
    ;ld bc, #0x0040
    ;ex de,hl
    ;
    ;ldir
    ;
    ;ld hl, #0xE000
    ;ld b, #0x7F
    ;ld c, #0x3F
    ;call changed_cpct_drawSprite_32x16
    call change_screen
ret