;Copyright 2020, SoftBytes
;This file is part of Liam's Awakening.
;
;   Liam's Awakening is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;   (at your option) any later version.
;
;   Liam's Awakening is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with Liam's Awakening.  If not, see https://www.gnu.org/licenses/.

.include "map_templates.h.s"
.include "templates.h.s"

; Structura de mapa
;e_map_id              = 0 ;id del mapa
;e_map_tile            = 1 ;Posicion de memoria al tile 2 bytes
;e_map_enemytemplate   = 3 ;Posicion de memoria del template con los enemigos del mapa
;e_map_izq             = 5 ;Marca si tiene salida a la izquierda con un 3
;e_map_izq_next        = 6 ;id del mapa a la izquierda
;e_map_der             = 7 ;Marca si tiene salida a la derecha com un 1
;e_map_der_next        = 8 ;Id del mapa a la derecha
;e_map_arr             = 9 ;Marca si tiene salida arriba con un 4
;e_map_arr_next        = 10;Id del mapa de arriba
;e_map_abj             = 11 ;Marca si tiene salida abajo con un 2
;e_map_abj_next        = 12;Id del mapa abajo

;; Mapas

mapa_0::
.db 0x00
;.dw #_level_0
.dw #_level1_map0_pack_end
.dw #enemy_template_0
.db 0x00
.db 0x00
.db 0x01
.db 0x01
.db 0x00
.db 0x00
.db 0x00
.db 0x00

mapa_1::
.db 0x01
.dw #_level1_map1_pack_end
.dw #enemy_template_1
.db 0x03
.db 0x00
.db 0x01
.db 0x02
.db 0x00
.db 0x00
.db 0x00
.db 0x00

mapa_2::
.db 0x02
.dw #_level1_map2_pack_end
.dw #enemy_template_2
.db 0x03
.db 0x01
.db 0x00
.db 0x00
.db 0x00
.db 0x00
.db 0x02
.db 0x03

mapa_3::
.db 0x03
.dw #_level1_map3_pack_end
.dw #enemy_template_3
.db 0x00
.db 0x00
.db 0x00
.db 0x00
.db 0x04
.db 0x02
.db 0x00
.db 0x00

lvl2_mapa_1::
.db 0x04
.dw #_level2_map1_pack_end
.dw #enemy_template_lvl2_map1
.db 0x00
.db 0x00
.db 0x00
.db 0x00
.db 0x04
.db 0x05
.db 0x00
.db 0x00

lvl2_mapa_2::
.db 0x05
.dw #_level2_map2_pack_end
.dw #enemy_template_lvl2_map2
.db 0x00
.db 0x00
.db 0x01
.db 0x06
.db 0x00
.db 0x00
.db 0x02
.db 0x04


lvl2_mapa_3::
.db 0x06
.dw #_level2_map3_pack_end
.dw #enemy_template_lvl2_map3
.db 0x03
.db 0x05
.db 0x00
.db 0x00
.db 0x00
.db 0x00
.db 0x00
.db 0x00


lvl3_mapa_1::
.db 0x07                 ;e_map_id
.dw #_level3_map1_pack_end        ;e_map_tile          
.dw #enemy_template_lvl3_map1    ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x02                 ;e_map_abj                  
.db 0x08                 ;e_map_abj_next
lvl3_mapa_2::
.db 0x08                 ;e_map_id
.dw #_level3_map2_pack_end        ;e_map_tile          
.dw #enemy_template_lvl3_map2    ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x01                 ;e_map_der   
.db 0x09                 ;e_map_der_next  
.db 0x04                 ;e_map_arr
.db 0x07                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next
lvl3_mapa_3::
.db 0x09                 ;e_map_id
.dw #_level3_map3_pack_end        ;e_map_tile          
.dw #enemy_template_lvl3_map3    ;e_map_enemytemplate    
.db 0x03                 ;e_map_izq       
.db 0x08                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x04                 ;e_map_arr
.db 0x0A                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next
lvl3_mapa_4::
.db 0x0A                 ;e_map_id
.dw #_level3_map4_pack_end        ;e_map_tile          
.dw #enemy_template_lvl3_map4    ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x04                 ;e_map_arr
.db 0x0B                 ;e_map_arr_next
.db 0x02                 ;e_map_abj                  
.db 0x09                 ;e_map_abj_next
lvl3_mapa_5::
.db 0x0B                 ;e_map_id
.dw #_level3_map5_pack_end        ;e_map_tile          
.dw #enemy_template_lvl3_map5    ;e_map_enemytemplate    
.db 0x03                 ;e_map_izq       
.db 0x0C                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x02                 ;e_map_abj                  
.db 0x0A                 ;e_map_abj_next
lvl3_mapa_6::
.db 0x0C                 ;e_map_id
.dw #_level3_map6_pack_end        ;e_map_tile          
.dw #enemy_template_lvl3_map6   ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x01                 ;e_map_der   
.db 0x0B                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next

lvl4_mapa_1::
.db 0x0D                ;e_map_id
.dw #_level4_map1_pack_end        ;e_map_tile          
.dw #enemy_template_lvl4_map1    ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x04                 ;e_map_arr
.db 0x0E                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next
lvl4_mapa_2::
.db 0x0E                ;e_map_id
.dw #_level4_map2_pack_end        ;e_map_tile          
.dw #enemy_template_lvl4_map2    ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x01                 ;e_map_der   
.db 0x0F                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x02                 ;e_map_abj                  
.db 0x0D                 ;e_map_abj_next
lvl4_mapa_3::
.db 0x0F                ;e_map_id
.dw #_level4_map3_pack_end        ;e_map_tile          
.dw #enemy_template_lvl4_map3    ;e_map_enemytemplate    
.db 0x03                 ;e_map_izq       
.db 0x0E                 ;e_map_izq_next          
.db 0x01                 ;e_map_der   
.db 0x10                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next
lvl4_mapa_4::
.db 0x10                ;e_map_id
.dw #_level4_map4_pack_end        ;e_map_tile          
.dw #enemy_template_lvl4_map4    ;e_map_enemytemplate    
.db 0x03                 ;e_map_izq       
.db 0x0F                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x02                 ;e_map_abj                  
.db 0x12                 ;e_map_abj_next
;lvl4_mapa_5::
;.db 0x11                ;e_map_id
;.dw #_level4_map5_pack_end        ;e_map_tile          
;.dw #enemy_template_lvl4_map5    ;e_map_enemytemplate    
;.db 0x00                 ;e_map_izq       
;.db 0x00                 ;e_map_izq_next          
;.db 0x00                 ;e_map_der   
;.db 0x00                 ;e_map_der_next  
;.db 0x04                 ;e_map_arr
;.db 0x10                 ;e_map_arr_next
;.db 0x02                 ;e_map_abj                  
;.db 0x12                 ;e_map_abj_next
lvl4_mapa_6::
.db 0x12                ;e_map_id
.dw #_level4_map6_pack_end        ;e_map_tile          
.dw #enemy_template_lvl4_map6    ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x04                 ;e_map_arr
.db 0x10                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next


lvl5_mapa_1::
.db 0x13                 ;e_map_id
.dw #_level5_map1_pack_end        ;e_map_tile          
.dw #enemy_template_lvl5_map1    ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x01                 ;e_map_der   
.db 0x14                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next
lvl5_mapa_2::
.db 0x14                 ;e_map_id
.dw #_level5_map2_pack_end        ;e_map_tile          
.dw #enemy_template_lvl5_map2    ;e_map_enemytemplate    
.db 0x03                 ;e_map_izq       
.db 0x13                 ;e_map_izq_next          
.db 0x01                 ;e_map_der   
.db 0x15                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next
lvl5_mapa_3::
.db 0x15                 ;e_map_id
.dw #_level5_map3_pack_end        ;e_map_tile          
.dw #enemy_template_lvl5_map3    ;e_map_enemytemplate    
.db 0x03                 ;e_map_izq       
.db 0x14                 ;e_map_izq_next          
.db 0x01                 ;e_map_der   
.db 0x16                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next
lvl5_mapa_4::
.db 0x16                 ;e_map_id
.dw #_level5_map4_pack_end        ;e_map_tile          
.dw #enemy_template_lvl5_map4    ;e_map_enemytemplate    
.db 0x03                 ;e_map_izq       
.db 0x15                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x02                 ;e_map_abj                  
.db 0x17                 ;e_map_abj_next
lvl5_mapa_5::
.db 0x17                 ;e_map_id
.dw #_level5_map5_pack_end        ;e_map_tile          
.dw #enemy_template_lvl5_map5    ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x04                 ;e_map_arr
.db 0x16                 ;e_map_arr_next
.db 0x02                 ;e_map_abj                  
.db 0x18                 ;e_map_abj_next
lvl5_mapa_6::
.db 0x18                 ;e_map_id
.dw #_level5_map6_pack_end        ;e_map_tile          
.dw #enemy_template_lvl5_map6    ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x04                 ;e_map_arr
.db 0x17                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next

lvl6_mapa_1::
.db 0x19                 ;e_map_id
.dw #_level6_map1_pack_end        ;e_map_tile          
.dw #enemy_template_lvl6_map1    ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x04                 ;e_map_arr
.db 0x1A                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next

lvl6_mapa_2::
.db 0x1A                 ;e_map_id
.dw #_level6_map2_pack_end        ;e_map_tile          
.dw #enemy_template_lvl6_map2    ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x04                 ;e_map_arr
.db 0x1B                 ;e_map_arr_next
.db 0x02                 ;e_map_abj                  
.db 0x19                 ;e_map_abj_next

lvl6_mapa_3::
.db 0x1B                 ;e_map_id
.dw #_level6_map3_pack_end        ;e_map_tile          
.dw #enemy_template_lvl6_map3    ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x04                 ;e_map_arr
.db 0x1C                 ;e_map_arr_next
.db 0x02                 ;e_map_abj                  
.db 0x1A                 ;e_map_abj_next

lvl6_mapa_4::
.db 0x1C                 ;e_map_id
.dw #_level6_map4_pack_end        ;e_map_tile          
.dw #enemy_template_lvl6_map4    ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x01                 ;e_map_der   
.db 0x1D                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x02                 ;e_map_abj                  
.db 0x1B                 ;e_map_abj_next

lvl6_mapa_5::
.db 0x1D                 ;e_map_id
.dw #_level6_map5_pack_end        ;e_map_tile          
.dw #enemy_template_lvl6_map5    ;e_map_enemytemplate    
.db 0x03                 ;e_map_izq       
.db 0x1C                 ;e_map_izq_next          
.db 0x01                 ;e_map_der   
.db 0x1E                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next

lvl6_mapa_6::
.db 0x1E                 ;e_map_id
.dw #_level6_map6_pack_end        ;e_map_tile          
.dw #enemy_template_lvl6_map6    ;e_map_enemytemplate    
.db 0x03                 ;e_map_izq       
.db 0x1D                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next


lvl_final::
.db 0x1F
.dw #_level_final_pack_end
.dw #enemy_template_0
.db 0x00
.db 0x00
.db 0x00
.db 0x00
.db 0x00
.db 0x00
.db 0x00
.db 0x00

lvl7_mapa_1::
.db 0x20                 ;e_map_id
.dw #_level7_map1_pack_end        ;e_map_tile          
.dw #enemy_template_lvl7_map1    ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x01                 ;e_map_der   
.db 0x21                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next

lvl7_mapa_2::
.db 0x21                 ;e_map_id
.dw #_level7_map2_pack_end        ;e_map_tile          
.dw #enemy_template_lvl7_map2    ;e_map_enemytemplate    
.db 0x03                 ;e_map_izq       
.db 0x20                 ;e_map_izq_next          
.db 0x01                 ;e_map_der   
.db 0x22                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next

lvl7_mapa_3::
.db 0x22                 ;e_map_id
.dw #_level7_map3_pack_end        ;e_map_tile          
.dw #enemy_template_lvl7_map3    ;e_map_enemytemplate    
.db 0x03                 ;e_map_izq       
.db 0x21                 ;e_map_izq_next          
.db 0x01                 ;e_map_der   
.db 0x23                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next

lvl7_mapa_4::
.db 0x23                 ;e_map_id
.dw #_level7_map4_pack_end        ;e_map_tile          
.dw #enemy_template_lvl7_map4    ;e_map_enemytemplate    
.db 0x03                 ;e_map_izq       
.db 0x22                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x04                 ;e_map_arr
.db 0x24                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next

lvl7_mapa_5::
.db 0x24                 ;e_map_id
.dw #_level7_map5_pack_end        ;e_map_tile          
.dw #enemy_template_lvl7_map5    ;e_map_enemytemplate    
.db 0x00                 ;e_map_izq       
.db 0x00                 ;e_map_izq_next          
.db 0x01                 ;e_map_der   
.db 0x25                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x02                 ;e_map_abj                  
.db 0x23                 ;e_map_abj_next

lvl7_mapa_6::
.db 0x25                 ;e_map_id
.dw #_level7_map6_pack_end        ;e_map_tile          
.dw #enemy_template_lvl7_map6    ;e_map_enemytemplate    
.db 0x03                 ;e_map_izq       
.db 0x24                 ;e_map_izq_next          
.db 0x00                 ;e_map_der   
.db 0x00                 ;e_map_der_next  
.db 0x00                 ;e_map_arr
.db 0x00                 ;e_map_arr_next
.db 0x00                 ;e_map_abj                  
.db 0x00                 ;e_map_abj_next


;; Array mapas
array_mapas::
.db 0x00 ;id del mapa
.dw #mapa_0 ;posicion del mapa 
.db 0x01 ;id del mapa
.dw #mapa_1 ;posicion del mapa 
.db 0x02 ;id del mapa
.dw #mapa_2 ;posicion del mapa 
.db 0x03 ;id del mapa
.dw #mapa_3 ;posicion del mapa 
.db 0x04
.dw #lvl2_mapa_1
.db 0x05
.dw #lvl2_mapa_2
.db 0x06
.dw #lvl2_mapa_3
.db 0x07
.dw #lvl3_mapa_1
.db 0x08
.dw #lvl3_mapa_2
.db 0x09
.dw #lvl3_mapa_3
.db 0x0A
.dw #lvl3_mapa_4
.db 0x0B
.dw #lvl3_mapa_5
.db 0x0C
.dw #lvl3_mapa_6
.db 0x0D
.dw #lvl4_mapa_1
.db 0x0E
.dw #lvl4_mapa_2
.db 0x0F
.dw #lvl4_mapa_3
.db 0x10
.dw #lvl4_mapa_4
;.db 0x11
;.dw #lvl4_mapa_5
.db 0x12
.dw #lvl4_mapa_6
.db 0x13
.dw #lvl5_mapa_1
.db 0x14
.dw #lvl5_mapa_2
.db 0x15
.dw #lvl5_mapa_3
.db 0x16
.dw #lvl5_mapa_4
.db 0x17
.dw #lvl5_mapa_5
.db 0x18
.dw #lvl5_mapa_6
.db 0x19
.dw #lvl6_mapa_1
.db 0x1A
.dw #lvl6_mapa_2
.db 0x1B
.dw #lvl6_mapa_3
.db 0x1C
.dw #lvl6_mapa_4
.db 0x1D
.dw #lvl6_mapa_5
.db 0x1E
.dw #lvl6_mapa_6
.db 0x1F
.dw #lvl_final
.db 0x20
.dw #lvl7_mapa_1
.db 0x21
.dw #lvl7_mapa_2
.db 0x22
.dw #lvl7_mapa_3
.db 0x23
.dw #lvl7_mapa_4
.db 0x24
.dw #lvl7_mapa_5
.db 0x25
.dw #lvl7_mapa_6



enemy_template_0::
.dw 0x0000

;; Estructuras enemigos
;;La x se divide entre 4 y la y se divide entre dos y se le resta 1, todo en hexadecimal vaya
enemy_template_1::
.dw #template_enemy3 ;template a usar  0-1
.db 0x10            ;x inciial enemigo 2
.db 0x16            ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy3 ;template a usar 
.db 0x20            ;x inciial enemigo
.db 0x4A            ;y inicial enemigo
.db 0x02            ;direccion del enemigo 
.dw #template_enemy3 ;template a usar 
.db 0x30            ;x inciial enemigo
.db 0x16            ;y inicial enemigo
.db 0x02            ;direccion del enemigo 
.dw 0x0000

enemy_template_2::
.dw #template_enemy2 ;template a usar 
.db 0x10            ;x inciial enemigo
.db 0x10            ;y inicial enemigo
.db 0x01            ;direccion del enemigo 
.dw #template_enemy2 ;template a usar 
.db 0x30            ;x inciial enemigo
.db 0x4F            ;y inicial enemigo
.db 0x03            ;direccion del enemigo 
.dw #template_enemy2 ;template a usar 
.db 0x25            ;x inciial enemigo
.db 0x31           ;y inicial enemigo
.db 0x03            ;direccion del enemigo 
.dw 0x0000

enemy_template_3::
.dw #template_enemy3 ;template a usar 
.db 0x06            ;x inciial enemigo
.db 0x28            ;y inicial enemigo
.db 0x02            ;direccion del enemigo 
.dw #template_enemy2 ;template a usar 
.db 0x26            ;x inciial enemigo
.db 0x2E            ;y inicial enemigo
.db 0x03            ;direccion del enemigo 
.dw #template_enemy3 ;template a usar 
.db 0x36            ;x inciial enemigo
.db 0x20            ;y inicial enemigo
.db 0x02            ;direccion del enemigo 
.dw #hyper_adrenaline ;template a usar 0-1
.db 0x22            ;x inciial enemigo 2
.db 0x68            ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo
.dw 0x0000

enemy_template_lvl2_map1::
.dw #template_enemy2 ;template a usar  0-1
.db 0x0C           ;x inciial enemigo 2
.db 0x2F            ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw #template_enemy2 ;template a usar  0-1
.db 0x30           ;x inciial enemigo 2
.db 0x37           ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x38            ;x inciial enemigo 2
.db 0x17            ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x14            ;x inciial enemigo 2
.db 0x0E            ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl2_map2::
.dw #template_enemy3 ;template a usar  0-1
.db 0x0A         ;x inciial enemigo 2
.db 0x20            ;y inicial enemigo 3
.db 0x02          ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x16          ;x inciial enemigo 2
.db 0x35           ;y inicial enemigo 3
.db 0x01           ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x1F          ;x inciial enemigo 2
.db 0x4C           ;y inicial enemigo 3
.db 0x01           ;direccion del enemigo 4
.dw #template_enemy3 ;template a usar  0-1
.db 0x36           ;x inciial enemigo 2
.db 0x1F           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl2_map3::
.dw #template_enemy2 ;template a usar  0-1
.db 0x10         ;x inciial enemigo 2
.db 0x43            ;y inicial enemigo 3
.db 0x01          ;direccion del enemigo 4
.dw #template_enemy3 ;template a usar  0-1
.db 0x2A         ;x inciial enemigo 2
.db 0x37          ;y inicial enemigo 3
.db 0x02          ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x38        ;x inciial enemigo 2
.db 0x62           ;y inicial enemigo 3
.db 0x03          ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x10         ;x inciial enemigo 2
.db 0x3B            ;y inicial enemigo 3
.db 0x01          ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x10        ;x inciial enemigo 2
.db 0x0C            ;y inicial enemigo 3
.db 0x01          ;direccion del enemigo 4
.dw #hyper_adrenaline ;template a usar 0-1
.db 0x10          ;x inciial enemigo 2
.db 0x28            ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo
.dw 0x0000


;;level 3
enemy_template_lvl3_map1::
.dw #template_enemy4 ;template a usar  0-1
.db 0x10           ;x inciial enemigo 2
.db 0x47           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x38           ;x inciial enemigo 2
.db 0x34           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy2 ;template a usar  0-1
.db 0x38            ;x inciial enemigo 2
.db 0x3F           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy3 ;template a usar  0-1
.db 0x34            ;x inciial enemigo 2
.db 0x6F            ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl3_map2::
.dw #template_enemy3 ;template a usar  0-1
.db 0x05          ;x inciial enemigo 2
.db 0x0F           ;y inicial enemigo 3
.db 0x02           ;direccion del enemigo 4
.dw #template_enemy3 ;template a usar  0-1
.db 0x07           ;x inciial enemigo 2
.db 0x57           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy3 ;template a usar  0-1
.db 0x1F            ;x inciial enemigo 2
.db 0x27           ;y inicial enemigo 3
.db 0x02           ;direccion del enemigo 4
.dw #template_enemy3 ;template a usar  0-1
.db 0x1D           ;x inciial enemigo 2
.db 0x57            ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy3 ;template a usar  0-1
.db 0x2B            ;x inciial enemigo 2
.db 0x1B;0F            ;y inicial enemigo 3
.db 0x04;02            ;direccion del enemigo 4
.dw #template_enemy3 ;template a usar  0-1
.db 0x29            ;x inciial enemigo 2
.db 0x1B;3F            ;y inicial enemigo 3
.db 0x02;04            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl3_map3::
.dw #template_enemy2 ;template a usar  0-1
.db 0x1C           ;x inciial enemigo 2
.db 0x4C           ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw #template_enemy2 ;template a usar  0-1
.db 0x30           ;x inciial enemigo 2
.db 0x53           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy2 ;template a usar  0-1
.db 0x28            ;x inciial enemigo 2
.db 0x25           ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw #template_enemy2 ;template a usar  0-1
.db 0x38            ;x inciial enemigo 2
.db 0x31            ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x38           ;x inciial enemigo 2
.db 0x43           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl3_map4::
.dw #template_enemy3 ;template a usar  0-1
.db 0x17           ;x inciial enemigo 2
.db 0x0F           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy3 ;template a usar  0-1
.db 0x14           ;x inciial enemigo 2
.db 0x2F           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy3 ;template a usar  0-1
.db 0x28          ;x inciial enemigo 2
.db 0x3F         ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x36            ;x inciial enemigo 2
.db 0x0A           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl3_map5::
.dw #template_enemy4 ;template a usar  0-1
.db 0x0C           ;x inciial enemigo 2
.db 0x3F           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x2E           ;x inciial enemigo 2
.db 0x23           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy3 ;template a usar  0-1
.db 0x1C            ;x inciial enemigo 2
.db 0x44           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy3 ;template a usar  0-1
.db 0x20            ;x inciial enemigo 2
.db 0x44            ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl3_map6::
.dw #template_enemy4 ;template a usar  0-1
.db 0x10           ;x inciial enemigo 2
.db 0x6B           ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x24           ;x inciial enemigo 2
.db 0x0C           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x13           ;x inciial enemigo 2
.db 0x57           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x0D            ;x inciial enemigo 2
.db 0x57           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x1A            ;x inciial enemigo 2
.db 0x57           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #hyper_adrenaline ;template a usar 0-1
.db 0x1C          ;x inciial enemigo 2
.db 0x3F            ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo
.dw 0x0000

;;level 4
enemy_template_lvl4_map1::
.dw #template_enemy2_Upgraded ;template a usar  0-1
.db 0x20           ;x inciial enemigo 2
.db 0x56           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy2_Upgraded ;template a usar  0-1
.db 0x14           ;x inciial enemigo 2
.db 0x3B           ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw #template_enemy2_Upgraded ;template a usar  0-1
.db 0x2B            ;x inciial enemigo 2
.db 0x24           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw 0x0000
enemy_template_lvl4_map2::
.dw #template_enemy2_Upgraded ;template a usar  0-1
.db 0x38           ;x inciial enemigo 2
.db 0x4F           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy2_Upgraded ;template a usar  0-1
.db 0x20           ;x inciial enemigo 2
.db 0x48           ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw #template_enemy3_Upgraded ;template a usar  0-1
.db 0x21            ;x inciial enemigo 2
.db 0x3F           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy3_Upgraded ;template a usar  0-1
.db 0x23            ;x inciial enemigo 2
.db 0x18           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw 0x0000
enemy_template_lvl4_map3::
.dw #template_enemy4_Upgraded ;template a usar  0-1
.db 0x0E           ;x inciial enemigo 2
.db 0x3F           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy4_Upgraded ;template a usar  0-1
.db 0x1A           ;x inciial enemigo 2
.db 0x19           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy4_Upgraded ;template a usar  0-1
.db 0x32            ;x inciial enemigo 2
.db 0x4F           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw 0x0000
enemy_template_lvl4_map4::
.dw #template_enemy4_Upgraded ;template a usar  0-1
.db 0x30           ;x inciial enemigo 2
.db 0x0C           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy4_Upgraded ;template a usar  0-1
.db 0x12           ;x inciial enemigo 2
.db 0x22           ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw #template_enemy4_Upgraded ;template a usar  0-1
.db 0x36            ;x inciial enemigo 2
.db 0x3F           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy4_Upgraded ;template a usar  0-1
.db 0x2B            ;x inciial enemigo 2
.db 0x52           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw 0x0000
;enemy_template_lvl4_map5::
;.dw #template_enemy4_Upgraded ;template a usar  0-1
;.db 0x08           ;x inciial enemigo 2
;.db 0x6B           ;y inicial enemigo 3
;.db 0x04            ;direccion del enemigo 4
;.dw #template_enemy4_Upgraded ;template a usar  0-1
;.db 0x38           ;x inciial enemigo 2
;.db 0x4B           ;y inicial enemigo 3
;.db 0x03            ;direccion del enemigo 4
;.dw #template_enemy2_Upgraded ;template a usar  0-1
;.db 0x08            ;x inciial enemigo 2
;.db 0x2F           ;y inicial enemigo 3
;.db 0x03            ;direccion del enemigo 4
;.dw #template_enemy2_Upgraded ;template a usar  0-1
;.db 0x18            ;x inciial enemigo 2
;.db 0x4B           ;y inicial enemigo 3
;.db 0x03            ;direccion del enemigo 4
;.dw 0x0000
enemy_template_lvl4_map6::
.dw #template_enemy3_Upgraded ;template a usar  0-1
.db 0x04           ;x inciial enemigo 2
.db 0x40           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy2_Upgraded ;template a usar  0-1
.db 0x20           ;x inciial enemigo 2
.db 0x6C           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy4_Upgraded ;template a usar  0-1
.db 0x04            ;x inciial enemigo 2
.db 0x70           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy4_Upgraded ;template a usar  0-1
.db 0x36            ;x inciial enemigo 2
.db 0x6C           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #hyper_adrenaline ;template a usar 0-1
.db 0x1E          ;x inciial enemigo 2
.db 0x40            ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo
.dw 0x0000

;;level 5
enemy_template_lvl5_map1::
.dw #template_enemy3_Upgraded ;template a usar  0-1
.db 0x06           ;x inciial enemigo 2
.db 0x10           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy4_Upgraded ;template a usar  0-1
.db 0x38           ;x inciial enemigo 2
.db 0x28           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy4_Upgraded ;template a usar  0-1
.db 0x38            ;x inciial enemigo 2
.db 0x4A           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw 0x0000


enemy_template_lvl5_map2::
.dw #template_enemy_shield_v ;template a usar  0-1
.db 0x1F           ;x inciial enemigo 2
.db 0x2F           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy_shield_v ;template a usar  0-1
.db 0x26           ;x inciial enemigo 2
.db 0x67           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shield_h ;template a usar  0-1
.db 0x04            ;x inciial enemigo 2
.db 0x0B           ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw 0x0000


enemy_template_lvl5_map3::
.dw #template_enemy_shield_v ;template a usar  0-1
.db 0x1E           ;x inciial enemigo 2
.db 0x2F           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy_shield_v ;template a usar  0-1
.db 0x06           ;x inciial enemigo 2
.db 0x10           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy_shield_v ;template a usar  0-1
.db 0x0B            ;x inciial enemigo 2
.db 0x50           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy4 ;template a usar  0-1
.db 0x30            ;x inciial enemigo 2
.db 0x0B           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_shield_v ;template a usar  0-1
.db 0x29           ;x inciial enemigo 2
.db 0x34           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy_shield_v ;template a usar  0-1
.db 0x2F           ;x inciial enemigo 2
.db 0x67           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy_shield_h ;template a usar  0-1
.db 0x37            ;x inciial enemigo 2
.db 0x57           ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw #template_enemy_shield_h ;template a usar  0-1
.db 0x29            ;x inciial enemigo 2
.db 0x3F           ;y inicial enemigo 3
.db 0x03           ;direccion del enemigo 4
.dw #reference ;template a usar 0-1
.db 0x38          ;x inciial enemigo 2
.db 0x70            ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo
.dw 0x0000


enemy_template_lvl5_map4::
.dw #template_enemy_shootMove_h_up ;template a usar  0-1
.db 0x10           ;x inciial enemigo 2
.db 0x68           ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw #template_enemy_shootMove_h_up ;template a usar  0-1
.db 0x20           ;x inciial enemigo 2
.db 0x4C           ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw #template_enemy_shootMove_h_up ;template a usar  0-1
.db 0x30            ;x inciial enemigo 2
.db 0x68           ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl5_map5::
.dw #template_enemy_shootMove_v_right ;template a usar  0-1
.db 0x08           ;x inciial enemigo 2
.db 0x18           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
;.dw #template_enemy_shootMove_v_right;template a usar  0-1
;.db 0x08           ;x inciial enemigo 2
;.db 0x38           ;y inicial enemigo 3
;.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shootMove_v_right ;template a usar  0-1
.db 0x08            ;x inciial enemigo 2
.db 0x50           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy_shootMove_v_left ;template a usar  0-1
.db 0x34           ;x inciial enemigo 2
.db 0x28           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
;.dw #template_enemy_shootMove_v_left ;template a usar  0-1
;.db 0x34           ;x inciial enemigo 2
;.db 0x40           ;y inicial enemigo 3
;.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shootMove_v_left ;template a usar  0-1
.db 0x34            ;x inciial enemigo 2
.db 0x60           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl5_map6::
.dw #template_enemy_shield_v ;template a usar  0-1
.db 0x1C           ;x inciial enemigo 2
.db 0x20           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy_shield_v ;template a usar  0-1
.db 0x20           ;x inciial enemigo 2
.db 0x60           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shootMove_v_right ;template a usar  0-1
.db 0x08           ;x inciial enemigo 2
.db 0x1D           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shootMove_v_right ;template a usar  0-1
.db 0x08            ;x inciial enemigo 2
.db 0x40           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy_shootMove_v_left ;template a usar  0-1
.db 0x34           ;x inciial enemigo 2
.db 0x2D           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shootMove_v_left ;template a usar  0-1
.db 0x34            ;x inciial enemigo 2
.db 0x60           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4s
.dw #hyper_adrenaline ;template a usar 0-1
.db 0x1E          ;x inciial enemigo 2
.db 0x70            ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo
.dw 0x0000

;;level 6
enemy_template_lvl6_map1::
.dw #template_enemy_melee_search_1 ;template a usar  0-1
.db 0x18           ;x inciial enemigo 2
.db 0x57           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_melee_search_1 ;template a usar  0-1
.db 0x38           ;x inciial enemigo 2
.db 0x3F           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_melee_search_1 ;template a usar  0-1
.db 0x20            ;x inciial enemigo 2
.db 0x2F           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
;.dw #template_enemy_melee_search_1 ;template a usar  0-1
;.db 0x10           ;x inciial enemigo 2
;.db 0x27           ;y inicial enemigo 3
;.db 0x01            ;direccion del enemigo 4
;.dw #template_enemy_melee_search_1 ;template a usar  0-1
;.db 0x20           ;x inciial enemigo 2
;.db 0x20           ;y inicial enemigo 3
;.db 0x03            ;direccion del enemigo 4
.dw 0x0000


enemy_template_lvl6_map2::
.dw #template_enemy_melee_search_1 ;template a usar  0-1
.db 0x2C           ;x inciial enemigo 2
.db 0x27           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_melee_search_1 ;template a usar  0-1
.db 0x2C           ;x inciial enemigo 2
.db 0x47           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_melee_search_2;template a usar  0-1
.db 0x2A            ;x inciial enemigo 2
.db 0x2F           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_melee_search_2 ;template a usar  0-1
.db 0x24            ;x inciial enemigo 2
.db 0x1F           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy_melee_search_2 ;template a usar  0-1
.db 0x12            ;x inciial enemigo 2
.db 0x4F           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_melee_search_2 ;template a usar  0-1
.db 0x18            ;x inciial enemigo 2
.db 0x40           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl6_map3::
.dw #template_enemy_melee_search_2 ;template a usar  0-1
.db 0x10            ;x inciial enemigo 2
.db 0x4F           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_melee_search_2 ;template a usar  0-1
.db 0x2C            ;x inciial enemigo 2
.db 0x22           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy_shield_v ;template a usar  0-1
.db 0x1C           ;x inciial enemigo 2
.db 0x20           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy_shield_v ;template a usar  0-1
.db 0x20           ;x inciial enemigo 2
.db 0x60           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl6_map4::
.dw #template_enemy_shooter_search ;template a usar  0-1
.db 0x08           ;x inciial enemigo 2
.db 0x54           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shooter_search ;template a usar  0-1
.db 0x22            ;x inciial enemigo 2
.db 0x23           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy_shooter_search ;template a usar  0-1
.db 0x10            ;x inciial enemigo 2
.db 0x23           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy_shooter_search ;template a usar  0-1
.db 0x16            ;x inciial enemigo 2
.db 0x3F           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shooter_search ;template a usar  0-1
.db 0x28           ;x inciial enemigo 2
.db 0x3F           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw 0x0000


enemy_template_lvl6_map5::
.dw #template_enemy_shootMove_h_down ;template a usar  0-1
.db 0x28            ;x inciial enemigo 2
.db 0x0F           ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw #template_enemy_shootMove_h_down ;template a usar  0-1
.db 0x14            ;x inciial enemigo 2
.db 0x0F           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_shootMove_h_up ;template a usar  0-1
.db 0x18            ;x inciial enemigo 2
.db 0x67           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_shootMove_h_up ;template a usar  0-1
.db 0x2C            ;x inciial enemigo 2
.db 0x67           ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw #template_enemy_melee_search_1 ;template a usar  0-1
.db 0x18            ;x inciial enemigo 2
.db 0x38           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_melee_search_1 ;template a usar  0-1
.db 0x18            ;x inciial enemigo 2
.db 0x3F           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl6_map6::
.dw #template_enemy_melee_search_1 ;template a usar  0-1
.db 0x28            ;x inciial enemigo 2
.db 0x68           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_melee_search_1 ;template a usar  0-1
.db 0x16            ;x inciial enemigo 2
.db 0x6F           ;y inicial enemigo 3
.db 0x01            ;direccion del enemigo 4
.dw #template_enemy_melee_search_2 ;template a usar  0-1
.db 0x18            ;x inciial enemigo 2
.db 0x2F           ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo 4
.dw #template_enemy_melee_search_2 ;template a usar  0-1
.db 0x14            ;x inciial enemigo 2
.db 0x47           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shooter_search ;template a usar  0-1
.db 0x16            ;x inciial enemigo 2
.db 0x0F           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #hyper_adrenaline ;template a usar 0-1
.db 0x36          ;x inciial enemigo 2
.db 0x12            ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo
.dw 0x0000


;;level 7
enemy_template_lvl7_map1::
.dw #template_enemy_shootMove_patron_1 ;template a usar  0-1
.db 0x24           ;x inciial enemigo 2
.db 0x2F           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_2 ;template a usar  0-1
.db 0x24           ;x inciial enemigo 2
.db 0x5F           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl7_map2::
.dw #template_enemy_shootMove_patron_2 ;template a usar  0-1
.db 0x2D           ;x inciial enemigo 2
.db 0x6F           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_2 ;template a usar  0-1
.db 0x1F           ;x inciial enemigo 2
.db 0x6F           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_1 ;template a usar  0-1
.db 0x2F           ;x inciial enemigo 2
.db 0x1F           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_1 ;template a usar  0-1
.db 0x20           ;x inciial enemigo 2
.db 0x27           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl7_map3::
.dw #template_enemy_shootMove_patron_1 ;template a usar  0-1
.db 0x32           ;x inciial enemigo 2
.db 0x6B           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_2 ;template a usar  0-1
.db 0x1E           ;x inciial enemigo 2
.db 0x6B           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_2 ;template a usar  0-1
.db 0x32           ;x inciial enemigo 2
.db 0x29           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_1 ;template a usar  0-1
.db 0x1E           ;x inciial enemigo 2
.db 0x29           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl7_map4::
.dw #template_enemy_shootMove_patron_2 ;template a usar  0-1
.db 0x38           ;x inciial enemigo 2
.db 0x23           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_1 ;template a usar  0-1
.db 0x24           ;x inciial enemigo 2
.db 0x47           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_1 ;template a usar  0-1
.db 0x38           ;x inciial enemigo 2
.db 0x6F           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_1 ;template a usar  0-1
.db 0x20           ;x inciial enemigo 2
.db 0x67           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl7_map5::
.dw #template_enemy_shootMove_patron_1 ;template a usar  0-1
.db 0x10           ;x inciial enemigo 2
.db 0x51           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_2 ;template a usar  0-1
.db 0x25           ;x inciial enemigo 2
.db 0x51           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_2 ;template a usar  0-1
.db 0x10          ;x inciial enemigo 2
.db 0x29           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_1 ;template a usar  0-1
.db 0x20           ;x inciial enemigo 2
.db 0x29           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw 0x0000

enemy_template_lvl7_map6::
.dw #template_enemy_shootMove_patron_2 ;template a usar  0-1
.db 0x30           ;x inciial enemigo 2
.db 0x17           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_1;template a usar  0-1
.db 0x20           ;x inciial enemigo 2
.db 0x67           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_2 ;template a usar  0-1
.db 0x34           ;x inciial enemigo 2
.db 0x67           ;y inicial enemigo 3
.db 0x04            ;direccion del enemigo 4
.dw #template_enemy_shootMove_patron_1 ;template a usar  0-1
.db 0x24           ;x inciial enemigo 2
.db 0x47           ;y inicial enemigo 3
.db 0x03            ;direccion del enemigo 4
.dw #hyper_adrenaline ;template a usar 0-1
.db 0x2A          ;x inciial enemigo 2
.db 0x3F            ;y inicial enemigo 3
.db 0x02            ;direccion del enemigo
.dw 0x0000